	INCDIR	"Include:"

;	include	"lvo.i"

	INCLUDE	"Exec/exec.i"
	include	"intuition/screens.i"
	INCLUDE	"Graphics/gfxbase.i"
	include	"graphics/videocontrol.i"
	INCLUDE	"Hardware/custom.i"
	INCLUDE	"Hardware/dmabits.i"
	INCLUDE	"Hardware/cia.i"
	INCLUDE	"Hardware/intbits.i"

	INCLUDE	"graphics/gfx.i"
	INCLUDE	"graphics/rastport.i"

	XREF	_LVOAllocMem
	XREF	_LVOFreeMem
	XREF	_LVOOpenLibrary
	XREF	_LVOCloseLibrary
	XREF	_LVOFindTask
	XREF	_LVOSetTaskPri
	XREF	_LVOForbid
	XREF	_LVOSupervisor
	XREF	_LVOPermit
	XREF	_LVOAlert
	XREF	_LVOCopyMemQuick

	XREF	_LVOLockPubScreen
	XREF	_LVOUnlockPubScreen
	XREF	_LVOMakeScreen
	XREF	_LVORethinkDisplay
	XREF	_LVODisplayAlert

	XREF	_LVOSetFont
	XREF	_LVOMove
	XREF	_LVOSetAPen
	XREF	_LVOLoadView
	XREF	_LVOWaitTOF
	XREF	_LVOVideoControl
	XREF	_LVOTextLength
	XREF	_LVOText
	XREF	_LVOStripFont
	XREF	_LVOAllocBitMap
	XREF	_LVOFreeBitMap
	XREF	_LVOWritePixelArray8
	XREF	_LVOClearScreen
	XREF	_LVOEraseRect



_custom	equ	$dff000

************************************************************************

 STRUCTURE gldata,0
	; *** Init/end stuff
	APTR	_SaveSP
	APTR	_SaveVBR
	APTR	_OldVB

	LONG	oldres
	LONG	oldtaskpri
	APTR	taskptr
	STRUCT	taglist,8*2+4,0

	WORD	_intreq
	WORD	_intena

	APTR	wbview				; WB view pointer
	APTR	wbscreen				; the WB screen


	; *** Library pointers
	APTR	_ExecBase
	APTR	_IntuitionBase
	APTR	_GfxBase



	ALIGNLONG

	ULONG	FrameCount
	ULONG	OldFrame


	APTR	copperlist
	APTR	_copperlist


	APTR	bmap				; normal h8 display
	APTR	bbbmap				; b&b bitmap
	APTR	textbmap				; text view
	APTR	backupbmap
	APTR	hackbmap
	APTR	bbsbmap


	STRUCT	rport,rp_SIZEOF
	STRUCT	bbport,rp_SIZEOF
	STRUCT	textport,rp_SIZEOF
	STRUCT	backupport,rp_SIZEOF
	STRUCT	hackrport,rp_SIZEOF
	STRUCT	bbsrport,rp_SIZEOF

	APTR	animbuffer

	APTR	tracebuffer
	APTR	tracebuffer2

	APTR	h8chunkybuffer

	STRUCT	animtbl,4*4

	; *** triggers for interrupt
	WORD	Fader_Steps
	WORD	Fader_Wait
	WORD	Fader_lrgb
	WORD	Fader_mrgb
	BYTE	Fader_Done


	BYTE	TRIG_DOWIPEBL		; stop doeff and wipe to black
	BYTE	TRIG_TEXT		; set to plot text
	BYTE	TRIG_DOEFF		; do pause effect no.
	ALIGNLONG
	APTR	TEXT_PTR			; ptr to text if TRIG_TEXT
	APTR	TEXT_RPORT
	APTR	TRIGGER
	APTR	TRIGGERH
	APTR	TRIGGER2

	APTR	ANIM_FRAMES
	APTR	ANIM_CURRPTR		; current frame
	APTR	ANIM_PTR			; first frame
	WORD	ANIM_FRWAIT
	WORD	ANIM_WAIT

	; *** Initer
	WORD	initer_vcenter
	WORD	initer_lines

	; *** NewLiner
	BYTE	nl_llwait
	BYTE	nl_color
	BYTE	nl_eolwait	; hmm
	BYTE	nl_letters
	BYTE	nl_hcenter
	ALIGNLONG
	APTR	nl_curtxt

	BYTE	w1_wait
	ALIGNWORD
	WORD	w2_wait
	WORD	w3_wait
	ALIGNLONG

	APTR	sp_Event

	; *** Clearer
	WORD	cl_ploffset
	WORD	cl_xmin
	WORD	cl_ymin
	WORD	cl_lines

	; *** Anim1/Anim11
	WORD	a1_ctr


	WORD	currfr
	WORD	prevfr

	WORD	xoffset
	WORD	yoffset

	WORD	adder

	BYTE	cnt
	ALIGNWORD

	; *** Ham 8 converter
	BYTE	oldr
	BYTE	oldg
	BYTE	oldb


	ALIGNLONG
	; interrupt data - for text handling
	WORD	letter			; last letter offset
	WORD	horizpos			; last letter pixel+1 at this x coord
	WORD	waits			; frames waited
	WORD	currwait			; frames to wait

	WORD	xbase
	WORD	ybase
	BYTE	lmode
	BYTE	skipparse
	BYTE	llwait
	BYTE	eolwait
	BYTE	ddummy
	ALIGNLONG
	APTR	curtxt


	BYTE	vb_ok
	BYTE	disable_ok

	ALIGNLONG
	STRUCT	chunkybuffer,320*256
	ALIGNLONG

 LABEL gldata_SIZEOF

******************************************************************
MO:	MACRO
	dc.w	\2 & -2
	dc.w	\1
	ENDM
WA:	MACRO
	dc.b	\2
	dc.b	\1 ! 1
	dc.w	$FFFE
	ENDM
WM:	MACRO
	dc.b	\2
	dc.b	\1 ! 1
	dc.w	\3 & -2
	ENDM
SK:	MACRO
	dc.b	\2
	dc.b	\1 ! 1
	dc.w	\3 ! 1
	ENDM
