/* generates frames for PC's raytracer */

#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#define POINTS 30

char *materials[]={
"#material",
"silke, 0.1, 0.1, 0.9,  0.6, 0.6, 0.5,  25.0,",
"#material",
"stigspeil, 0.1, 0.15, 0.3,  0.6, 0.1, 0.95,  50.0,",
"#light",
"-100, 200, -400,  1.0, 1.0, 1.0,  500000.0,",
"none",
};

int main(int argc, char **argv) {
  double x, y, counter, offset;
  int indeks, i; 
  float frames, frame;
  char *ptr;

  if(argc!=1) {
    frame=atof(argv[1]);
    frames=atof(argv[2]);

    offset=(2*PI/POINTS)/frames*frame;
  }
  else offset=0.0;

  /* print standard information */
  /* bgcol(r,g,b), ambli lys(r,g,b), eye_range */
  printf("#scene\n0.1, 0.1, 0.1,  1.0, 1.0, 1.0,  2000.0,\n");
  /* src(x,y,z), dst(x,y,z) */
  printf("1000.0, 100.0, -800.0,   0.0, 50.0, 0.0,\n");
  printf("0.0, 1.0,\n1000, 10, 320, 200, 1,\n");

  i=0;
  ptr=materials[i];
  while(strcmp(ptr, "none")) {
    printf("%s\n", ptr);
    i++;
    ptr=materials[i];
  }

  /* print objects */
  printf("#sphere\nstigspeil, 0, -500, 250, 600,\n");

  for(counter=PI-PI/4+offset; counter>PI/4; counter-=(2*PI/POINTS))
    {
      x=600*cos(counter);
      y=600*sin(counter);
      y=y-500.0;
      
      printf("#sphere\nsilke, %f, %f, 0, 75,\n", x, y);
    }
}
