/* generates frames for PC's raytracer */

#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#define POINTS 24

char *materials[]={
"#material",
"silke, 0.0, 0.0, 0.0,  0.2, 0.2, 0.99,  25.0,",
"#material",
"speil, 0.0, 0.0, 0.5,  0.3, 0.1, 0.98,  10.0,",
"#material",
"text1, 0.3, 0.9, 0.0,  0.6, 0.5, 0.5,  15.0,",
"#material",
"text2, 0.0, 0.3, 0.9,  0.6, 0.5, 0.5,  15.0,",
"#material",
"text3, 0.9, 0.0, 0.3,  0.6, 0.5, 0.5,  15.0,",
"#light",
"900, -450, 800,  1.0, 1.0, 1.0,  500000.0,",
"none",
};

int main(int argc, char **argv) {
  double x, y, counter, offset;
  double x2, y2;
  int indeks, i; 
  float frames, frame;
  char *ptr;

  if(argc!=1) {
    frame=atof(argv[1]);
    frames=atof(argv[2]);

    offset=(2*PI/POINTS)/frames*frame;
  }
  else offset=0.0;

  /* print standard information */
  /* bgcol(r,g,b), ambli lys(r,g,b), eye_range */
  printf("#scene\n0.1, 0.1, 0.1,  1.0, 1.0, 1.0,  2000.0,\n");
  /* src(x,y,z), dst(x,y,z) */
  printf("1000.0, -400.0, 800.0,   0.0, 0.0, 0.0,\n");
  printf("0.0, 1.0,\n1000, 10, 320, 200, 1,\n");

  i=0;
  ptr=materials[i];
  while(strcmp(ptr, "none")) {
    printf("%s\n", ptr);
    i++;
    ptr=materials[i];
  }

  /* print objects */
  printf("#sphere\nsilke, 0, 0, 0, 100,\n");

  for(counter=0+offset; counter<2*PI; counter+=(2*PI/POINTS))
    {
      x=150*cos(counter);
      y=150*sin(counter);
      
      printf("#sphere\ntext3, %f, %f, 0, 30,\n", x, y);
      printf("#sphere\ntext1, 0, %f, %f, 30,\n", x, y);
      printf("#sphere\ntext2, %f, 0, %f, 30,\n", x, y);
    }
}
