/* generates frames for PC's raytracer */

#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#define POINTS 7

char *materials[]={
"#material",
"silke, 0.8, 0.1, 0.1,  0.6, 0.6, 0.5,  25.0,",
"#material",
"speil, 0.3, 0.0, 0.5,  0.6, 0.1, 0.95,  50.0,",
"#light",
"-100, 200, -400,  1.0, 1.0, 1.0,  500000.0,",
"none",
};

int main(int argc, char **argv) {
  double x, y, counter, offset;
  int indeks, i; 
  float frames, frame;
  char *ptr;

  if(argc!=1) {
    frame=atof(argv[1]);
    frames=atof(argv[2]);

    offset=(2*PI/POINTS)/frames*frame;
  }
  else offset=0.0;

  /* print standard information */
  /* bgcol(r,g,b), ambli lys(r,g,b), eye_range */
  printf("#scene\n0.1, 0.1, 0.1,  1.0, 1.0, 1.0,  2000.0,\n");
  /* src(x,y,z), dst(x,y,z) */
  printf("-800.0, -800.0, -1000.0,   0.0, 0.0, 0.0,\n");
  printf("0.0, 1.0,\n1000, 10, 320, 200, 1,\n");

  i=0;
  ptr=materials[i];
  while(strcmp(ptr, "none")) {
    printf("%s\n", ptr);
    i++;
    ptr=materials[i];
  }

  /* print objects */
  printf("#sphere\nsilke, 0, 0, 0, 100,\n");

  for(counter=0+offset; counter<=2*PI; counter+=(2*PI/POINTS))
    {
      x=200*cos(counter);
      y=200*sin(counter);
      
      printf("#sphere\nspeil, %f, %f, 0, 75,\n", x, y);
    }
}
