/* generates frames for PC's raytracer */

#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#define POINTS 7

#define RADIUS 70.0

char *materials[]={
"#material",
"blue, 0.2, 0.1, 0.15,  0.4, 0.1, 0.99,  100.0,",
"#material",
"silke5, 0.85, 0.85, 0.85,  0.1, 0.1, 0.8,  40.0,",
"none",
};

int main(int argc, char **argv) {
  double x, y, z, ny, nx, nz, counter, offset;
  int indeks, i; 
  float frames, frame;
  char *ptr;
  char *lineptr;

  if(argc!=1) {
    frame=atof(argv[1]);
    frames=atof(argv[2]);

    offset=(2*PI)/frames*frame;
  }
  else offset=0.0;

  /* print standard information */
  /* bgcol(r,g,b), ambli lys(r,g,b), eye_range */
  printf("#scene\n.15, .1, .2,  1.0, 1.0, 1.0,  2000.0,\n");
  /* src(x,y,z), dst(x,y,z) */

  printf("400.0, 400.0, -800.0,   0.0, 0.0, 0.0,\n");
  printf("0.0, 1.0,\n1000, 10, 320, 200, 1,\n");

  ptr=materials[i];
  while(strcmp(ptr, "none")) {
    printf("%s\n", ptr);
    i++;
    ptr=materials[i];
  }

  printf("#light\n");
  printf("0, 200, -400,  0.2, 0.3, 0.7,  500000.0,");  

/*  printf("#light\n");
  printf("0, %f, %f,  0.0, 0.0, 0.7,  500000.0,",RADIUS*cos(offset),RADIUS*sin(offset));
  printf("#light\n");
  printf("%f, %f, 0,  0.0, 0.7, 0.0,  500000.0,",RADIUS*cos(offset+PI/8),RADIUS*sin(offset)); */
  printf("#light\n");
  printf("%f, 0, %f,  0.7, 0.0, 0.0,  500000.0,",RADIUS*cos(offset+2*PI/8),RADIUS*sin(offset));

  /* print objects */
/*  printf("#triangle\n");
  printf("blue, 0,0,0, -50,50,-50, 50,50,-50, 50,-50,-50,\n");
  printf("#triangle\n");
  printf("blue, 0,0,0, -50,50,-50, 50,-50,-50, -50,-50,-50,\n"); 

  printf("#triangle\n");
  printf("blue, 0,0,0, -50,50,-50, 50,50,-50, 50,50,50,\n");
  printf("#triangle\n");
  printf("blue, 0,0,0, -50,50,-50, 50,50,50, -50,50,50,\n");

  printf("#triangle\n");
  printf("blue, 0,0,0, -50,-50,-50, 50,-50,-50, 50,-50,50,\n");
  printf("#triangle\n");
  printf("blue, 0,0,0, -50,-50,-50, 50,-50,50, -50,-50,50,\n");

  printf("#triangle\n");
  printf("blue, 0,0,0, 50,50,-50, 50,50,50, 50,-50,50,\n");
  printf("#triangle\n");
  printf("blue, 0,0,0, 50,50,-50, 50,-50,-50, 50,-50,50,\n");

  printf("#triangle\n");
  printf("blue, 0,0,0, -50,50,-50, -50,50,50, -50,-50,50,\n");
  printf("#triangle\n");
  printf("blue, 0,0,0, -50,50,-50, -50,-50,-50, -50,-50,50,\n");
*/
  printf("#sphere\n");
  printf("silke5, 0,120,0, 40,\n");
  printf("#sphere\n");
  printf("silke5, -120,0,0, 40,\n");
  printf("#sphere\n");
  printf("silke5, 0,-120,0, 40,\n");
  printf("#sphere\n");
  printf("silke5, 120,0,0, 40,\n");
  printf("#sphere\n");
  printf("silke5, 0,0,120, 40,\n");
  printf("#sphere\n");
  printf("silke5, 0,0,-120, 40,\n");

  
}
