/* generates frames for PC's raytracer */

#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#define POINTS 7

#define RADIUS 5.0
char *logo[]={
  "010000000000000",
  "111101110011110",
  "010001001010101",
  "010001000010101",
  "001101000010101",
  "000000000000000",
  "000000000000000",
};


char *materials[]={
"#material",
"silke, 0.2, 0.1, 0.8,  0.6, 0.6, 0.5,  25.0,",
"#material",
"silke2, 0.9, 0.1, 0.1,  0.3, 0.1, 0.3,  25.0,",
"#material",
"silke3, 0.1, 0.9, 0.1,  0.3, 0.1, 0.5,  25.0,",
"#material",
"blue, 0.1, 0.1, 0.8,  0.3, 0.1, 0.5,  1000.0,",
"#material",
"silke5, 0.05, 0.05, 0.05,  0.1, 0.1, 0.98,  200.0,",
"#light",
"60, -50, -100,  0.1, 0.6, 0.90,  500000.0,",
"#light",
"-90, 50, -100,  0.1, 0.8, 0.60,  500000.0,",
"none",
};

int main(int argc, char **argv) {
  double x, y, counter, offset;
  int indeks, i; 
  float frames, frame;
  char *ptr;
  char *lineptr;

  if(argc!=1) {
    frame=atof(argv[1]);
    frames=atof(argv[2]);

    offset=(2*PI/POINTS)/frames*frame;
  }
  else offset=0.0;

  /* print standard information */
  /* bgcol(r,g,b), ambli lys(r,g,b), eye_range */
  printf("#scene\n0.28, 0.08, 0.25,  1.0, 1.0, 1.0,  2000.0,\n");
  /* src(x,y,z), dst(x,y,z) */
  printf("0.0, 0.0, -700.0,   0.0, 0.0, 0.0,\n");
  printf("0.0, 1.0,\n1000, 10, 320, 200, 1,\n");

  i=0;

  ptr=materials[i];
  while(strcmp(ptr, "none")) {
    printf("%s\n", ptr);
    i++;
    ptr=materials[i];
  }

  /* print objects */
  y=60.0;
  printf("#triangle\n");
  printf("blue, 0,0,0, -300,-150,150, -100,150,900, 350,0,10,\n"); 
  for(i=0; i<6; i++) {
    lineptr=logo[i];
    x=-185.0;
    while(*lineptr!='\0') {
      if(*lineptr=='1') {
      printf("#sphere\n");
      printf("silke5, %f,%f,%f, %f,\n",
	     x, y, 0.0, 23.0); 
     }
      lineptr++;
      x+=26.0;
    }
    y=y-30.0;
  }
}
