; ***********************************************
; "Speed" - Triumph intro released at TG95
; ***********************************************
; Part:
; Main controller
; ***********************************************

; ***********************************************
; CREDITS FOR THIS PART:
; ***********************************************
; Main coder:
; Nils "Darkman" Corneliusen
; (controller, glue, hacks, system interface)
; ***********************************************
; Additional coding:
; Carl "Smeagol" Aaby
; (filled vector part and intro vector zoomer)
; ***********************************************

; ***********************************************
; Disclaimer:
; PRELIMINARY AND CONFIDENTIAL!
; This code is to be considered as the private
; property of Nils Corneliusen, and may not be
; distributed in any way.
; ***********************************************

INTUI_V36_NAMES_ONLY	equ	1

	MACHINE	MC68040

	OUTPUT	start.o
	OPT	C+				; Case insensitivity?
	OPT	D-				; Debug info?
	OPT	L+				; Linkable code?
	OPT	P-				; PC checking?

	incdir	"Speed:"
	include	"global.i"

	; *** C++ controller
	XDEF	_asmHitMe__Fv		; start setup
;	XDEF	_ent0__Fv		; entry point 0
;	XDEF	_ent2__Fv		; entry point 2

	XDEF	_entf1__Fv		; entry point for anim1
	XDEF	_entf2__Fv		; entry point for anim2
	XDEF	_entf3__Fv		; entry point for anim3
	XDEF	_entf4__Fv		; entry point for anim4
	XDEF	_entf5__Fv		; entry point for anim4
	XDEF	_entf6__Fv		; entry point for anim4
	XDEF	_ents1__Fv		; entry point for still1

	; *** To tracer
	XDEF	_DestPtr
	XDEF	_ScenePtr

	; *** Fontglue routines
	XREF	InitFGFont
	XREF	FGFont

	; *** Prorunner replay
	XREF	pr_init
	XREF	pr_music
	XREF	pr_end
	XREF	pr_Vectorbasept
	XREF	pr_module
	XREF	pr_Enable


;zoomstart	equ	8200
;zoomend		equ	16000
;zoomspeed	equ	200
;width		equ	40

width			equ	40
wait			equ	100


_asmHitMe__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	#gldata_SIZEOF,d0
	move.l	#MEMF_PUBLIC!MEMF_CLEAR,d1
	move.l	4.w,a6
	jsr	_LVOAllocMem(a6)
	movea.l	d0,a5
	tst.l	d0
	bne.b	.hey
	bra	QuitUgly
.hey:	lea	HARDBASE(pc),a0
	move.l	a5,(a0)
	move.l	a6,_ExecBase(a5)
	move.l	a7,_SaveSP(a5)


	bsr	Init


; ***************************************************************************
; Main part - contains several entry points for the tracer
; ***************************************************************************

;Main:
xx:

	lea	_custom,a6
	move.l	#NormCopper,cop1lc(a6)
	move.l	#CarlText,TRIGGERH(a5)


	lea	_custom,a6
	move.l	#NormCopper,cop1lc(a6)

;	move.l	#Copperlist2,cop1lc(a6)
;	move.l	#Copperlist3,cop1lc(a6)



	; *** Start first text
	lea	control0(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

;.cola:	btst.b	#6,$bfe001
;	bne.b	.cola


; ***********************************************
; Anim 1
; ***********************************************

	lea	redc_animtbl,a1
	move.l	h8chunkybuffer(a5),a2
	moveq	#8-1,d3
tlp:	move.l	tracebuffer(a5),_DestPtr
	move.l	(a1)+,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_entf1__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	movem.l	a1/d3,-(a7)

	move.w	#200-1,d7
	move.l	tracebuffer(a5),a3
	bsr	C24toH8

	movem.l	(a7)+,a1/d3
	dbra	d3,tlp


;.x:	tst.b	stop
;	beq.b	.x


	; *** wait until text finished
.lps:	tst.b	TRIG_TEXT(a5)
	bne.b	.lps

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)

	; *** Do h8c to h8p conversion
	move.l	h8chunkybuffer(a5),a2
	move.l	animbuffer(a5),a4
	moveq	#8-1,d7

.lp2:	moveq	#0,d0
	move.w	d0,d1
	move.w	#319,d2
	move.w	#200-1,d3
	lea	hackrport(a5),a0
	lea	backupport(a5),a1
;	move.l	a2,a2
	move.l	_GfxBase(a5),a6
	move.b	#1,gfxlock
	jsr	_LVOWritePixelArray8(a6)
	clr.b	gfxlock

	move.l	hackbmap(a5),a3
	lea	bm_Planes(a3),a3
	moveq	#8-1,d6
	move.l	_ExecBase(a5),a6
.lp:	move.l	(a3)+,a0
	move.l	a4,a1
	move.l	#(40*200),d0
	jsr	_LVOCopyMemQuick(a6)
	add.l	#40*200,a4
	dbra	d6,.lp

	add.l	#320*200,a2
	dbra	d7,.lp2

	; fade to black
	clr.b	Fader_Done(a5)
	move.l	#Fader,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee


	move.w	#8-1,a1_ctr(a5)
	move.l	animbuffer(a5),ANIM_PTR(a5)
	move.l	animbuffer(a5),ANIM_CURRPTR(a5)
	move.w	#0,ANIM_FRWAIT(a5)
	move.w	#0,ANIM_WAIT(a5)
	move.w	#8-1,ANIM_FRAMES(a5)
	move.l	#Anim1,TRIGGER2(a5)

	lea	$dff000,a6
	move.l	#Copperlist3,cop1lc(a6)

	lea	ControlDown(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

;.heh:	btst.b	#6,$bfe001
;	bne.b	.heh


; ***********************************************
; Anim 2
; ***********************************************

	lea	juggler_animtbl,a1
	move.l	h8chunkybuffer(a5),a2
	moveq	#4-1,d3
tlp2:	move.l	tracebuffer(a5),_DestPtr
	move.l	(a1)+,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_entf2__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	movem.l	a1/d3,-(a7)

	bsr	FixSize

	move.w	#200-1,d7
	move.l	tracebuffer(a5),a3
	bsr	C24toH8

	movem.l	(a7)+,a1/d3
	dbra	d3,tlp2


	; *** wait until text finished
.nee:	tst.b	TRIG_TEXT(a5)
	bne.b	.nee

	clr.b	Fader_Done(a5)
	move.l	#Fader,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)

	; *** Do h8c to h8p conversion
	move.l	h8chunkybuffer(a5),a2
	move.l	animbuffer(a5),a4
	moveq	#4-1,d7

.lp2:	moveq	#0,d0
	move.w	d0,d1
	move.w	#319,d2
	move.w	#200-1,d3
	lea	hackrport(a5),a0
	lea	backupport(a5),a1
;	move.l	a2,a2
	move.l	_GfxBase(a5),a6
	move.b	#1,gfxlock
	jsr	_LVOWritePixelArray8(a6)
	clr.b	gfxlock

	move.l	hackbmap(a5),a3
	lea	bm_Planes(a3),a3
	moveq	#8-1,d6
	move.l	_ExecBase(a5),a6
.lp:	move.l	(a3)+,a0
	move.l	a4,a1
	move.l	#(40*200),d0
	jsr	_LVOCopyMemQuick(a6)
	add.l	#40*200,a4
	dbra	d6,.lp

	add.l	#320*200,a2
	dbra	d7,.lp2

	move.w	#4-1,a1_ctr(a5)
	move.l	animbuffer(a5),ANIM_PTR(a5)
	move.l	animbuffer(a5),ANIM_CURRPTR(a5)
	move.w	#5-1,ANIM_FRWAIT(a5)
	move.w	#5-1,ANIM_WAIT(a5)
	move.w	#4-1,ANIM_FRAMES(a5)
	move.l	#Anim1,TRIGGER2(a5)

	bsr	Wait2f
	lea	$dff000,a6
	move.l	#Copperlist3,cop1lc(a6)


	lea	ControlDown10(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

;.heh:	btst.b	#6,$bfe001
;	bne.b	.heh


; ***********************************************
; Anim 3
; ***********************************************


	; *** precalc anim3
	lea	blue_animtbl,a1
	move.l	h8chunkybuffer(a5),a2
	moveq	#4-1,d3
tlp3:	move.l	tracebuffer(a5),_DestPtr
	move.l	(a1)+,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_entf3__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	movem.l	a1/d3,-(a7)

	move.w	#200-1,d7
	move.l	tracebuffer(a5),a3
	bsr	C24toH8

	movem.l	(a7)+,a1/d3
	dbra	d3,tlp3


	; *** wait until text finished
.yee:	tst.b	TRIG_TEXT(a5)
	bne.b	.yee

	clr.b	Fader_Done(a5)
	move.l	#Fader,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)

	; *** Do h8c to h8p conversion
	move.l	h8chunkybuffer(a5),a2
	move.l	animbuffer(a5),a4
	moveq	#8-1,d7

.lp2:	moveq	#0,d0
	move.w	d0,d1
	move.w	#319,d2
	move.w	#200-1,d3
	lea	hackrport(a5),a0
	lea	backupport(a5),a1
;	move.l	a2,a2
	move.l	_GfxBase(a5),a6
	move.b	#1,gfxlock
	jsr	_LVOWritePixelArray8(a6)
	clr.b	gfxlock

	move.l	hackbmap(a5),a3
	lea	bm_Planes(a3),a3
	moveq	#8-1,d6
	move.l	_ExecBase(a5),a6
.lp:	move.l	(a3)+,a0
	move.l	a4,a1
	move.l	#(40*200),d0
	jsr	_LVOCopyMemQuick(a6)
	add.l	#40*200,a4
	dbra	d6,.lp

	add.l	#320*200,a2
	dbra	d7,.lp2

	move.w	#4-1,a1_ctr(a5)
	move.l	animbuffer(a5),ANIM_PTR(a5)
	move.l	animbuffer(a5),ANIM_CURRPTR(a5)
	move.w	#0,ANIM_FRWAIT(a5)
	move.w	#0,ANIM_WAIT(a5)
	move.w	#4-1,ANIM_FRAMES(a5)
	move.l	#Anim1,TRIGGER2(a5)

	bsr	Wait2f
	lea	$dff000,a6
	move.l	#Copperlist3,cop1lc(a6)


	lea	ControlDown20(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

;.heh:	btst.b	#6,$bfe001
;	bne.b	.heh



; ***********************************************
; Anim 4
; ***********************************************

	; do frames 1-4 first
	lea	col8_animtbl,a1
	move.l	h8chunkybuffer(a5),a2
	moveq	#4-1,d3
tlp4:	move.l	tracebuffer(a5),_DestPtr
	move.l	(a1)+,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_entf4__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	movem.l	a1/d3,-(a7)

	move.w	#200-1,d7
	move.l	tracebuffer(a5),a3
	bsr	C24toH8

	movem.l	(a7)+,a1/d3
	dbra	d3,tlp4

	; text wait?

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)
	move.l	#Empty,TRIGGERH(a5)

	; start bbs part
	lea	_custom,a6
	move.l	#copper,cop1lc(a6)
	bsr	CVStartup
	move.l	#CarlVec,TRIGGERH(a5)

	clr.b	Fader_Done(a5)
	move.l	#FaderC,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee


	move.l	FrameCount(a5),d0
	add.l	#300,d0
.lhey:	cmp.l	FrameCount(a5),d0
	bne.b	.lhey
	lea	ControlBBS(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	bbsrport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

	; precalc frames 5-6
	lea	col8_animtbl,a1
	add.l	#4*4,a1
	move.l	h8chunkybuffer(a5),a2
	add.l	#320*200*4,a2
	moveq	#2-1,d3
tlp5:	move.l	tracebuffer(a5),_DestPtr
	move.l	(a1)+,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_entf5__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	movem.l	a1/d3,-(a7)

	move.w	#200-1,d7
	move.l	tracebuffer(a5),a3
	bsr	C24toH8

	movem.l	(a7)+,a1/d3
	dbra	d3,tlp5


	; *** wait until text finished
.xee:	tst.b	TRIG_TEXT(a5)
	bne.b	.xee

	; do zoomout
	move.b	#2,startzoom

.gee:	tst.b	CVstop
	beq.b	.gee

	clr.b	Fader_Done(a5)
	move.l	#SFader,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee

	; do something else
	bsr	Wait2f
	lea	_custom,a6
	move.l	#NormCopper,cop1lc(a6)

	lea	controlgr(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

	; precalc frames 7-8
	lea	col8_animtbl,a1
	add.l	#4*6,a1
	move.l	h8chunkybuffer(a5),a2
	add.l	#320*200*6,a2
	moveq	#2-1,d3
tlp6:	move.l	tracebuffer(a5),_DestPtr
	move.l	(a1)+,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_entf6__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	movem.l	a1/d3,-(a7)

	move.w	#200-1,d7
	move.l	tracebuffer(a5),a3
	bsr	C24toH8

	movem.l	(a7)+,a1/d3
	dbra	d3,tlp6

	; wait for textend
.lps:	tst.b	TRIG_TEXT(a5)
	bne.b	.lps

	clr.b	Fader_Done(a5)
	move.l	#Fader,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)
	move.l	#Empty,TRIGGERH(a5)

	; *** Do h8c to h8p conversion
	move.l	h8chunkybuffer(a5),a2
	move.l	animbuffer(a5),a4
	moveq	#8-1,d7

.lp2:	moveq	#0,d0
	move.w	d0,d1
	move.w	#319,d2
	move.w	#200-1,d3
	lea	hackrport(a5),a0
	lea	backupport(a5),a1
;	move.l	a2,a2
	move.l	_GfxBase(a5),a6
	move.b	#1,gfxlock
	jsr	_LVOWritePixelArray8(a6)
	clr.b	gfxlock

	move.l	hackbmap(a5),a3
	lea	bm_Planes(a3),a3
	moveq	#8-1,d6
	move.l	_ExecBase(a5),a6
.lp:	move.l	(a3)+,a0
	move.l	a4,a1
	move.l	#(40*200),d0
	jsr	_LVOCopyMemQuick(a6)
	add.l	#40*200,a4
	dbra	d6,.lp

	add.l	#320*200,a2
	dbra	d7,.lp2

	move.w	#8-1,a1_ctr(a5)
	move.l	animbuffer(a5),ANIM_PTR(a5)
	move.l	animbuffer(a5),ANIM_CURRPTR(a5)
	move.w	#0,ANIM_FRWAIT(a5)
	move.w	#0,ANIM_WAIT(a5)
	move.w	#8-1,ANIM_FRAMES(a5)
	move.l	#Anim1,TRIGGER2(a5)

	bsr	Wait2f
	lea	$dff000,a6
	move.l	#Copperlist3,cop1lc(a6)

	lea	ControlDown30(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

;.jkl:	btst.b	#6,$bfe001
;	bne.b	.jkl


	; *** Start precalcing the cool still pic
	move.l	tracebuffer(a5),_DestPtr
	lea	still3_pic,a0
	move.l	a0,_ScenePtr
	movem.l	d0-d7/a0-a6,regz2
	movem.l	(a7)+,d0-d7/a0-a6
	rts
_ents1__Fv:
	movem.l	d0-d7/a0-a6,-(a7)
	movem.l	regz2,d0-d7/a0-a6

	move.w	#256-1,d7
	move.l	h8chunkybuffer(a5),a2
	move.l	tracebuffer(a5),a3
	bsr	C24toH8


.lps:	tst.b	TRIG_TEXT(a5)
	bne.b	.lps

	clr.b	Fader_Done(a5)
	move.l	#Fader,TRIGGER2(a5)
.aee:	tst.b	Fader_Done(a5)
	beq.b	.aee

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)

	; *** Do h8c to h8p conversion
	moveq	#0,d0
	move.w	d0,d1
	move.w	#319,d2
	move.w	#256-1,d3
	lea	hackrport(a5),a0
	lea	backupport(a5),a1
	move.l	h8chunkybuffer(a5),a2
	move.l	animbuffer(a5),a4
	move.l	_GfxBase(a5),a6
	move.b	#1,gfxlock
	jsr	_LVOWritePixelArray8(a6)
	clr.b	gfxlock

	move.l	hackbmap(a5),a3
	lea	bm_Planes(a3),a3
	moveq	#8-1,d6
	move.l	_ExecBase(a5),a6
.lp:	move.l	(a3)+,a0
	move.l	a4,a1
	move.l	#(40*256),d0
	jsr	_LVOCopyMemQuick(a6)
	add.l	#40*256,a4
	dbra	d6,.lp


	; *** Play sample!
;	clr.b	Fader_Done(a5)
;	move.l	#Fader,TRIGGER2(a5)
;.xee:	tst.b	Fader_Done(a5)
;	beq.b	.xee

	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)

	bsr	Wait2f

	clr.b	pr_Enable
	bsr	Wait2f
	lea	_custom,a6
	move.w	#%0000000000001111,dmacon(a6)

	lea	ControlMove(pc),a0
	move.l	a0,TEXT_PTR(a5)
	lea	textport(a5),a0
	move.l	a0,TEXT_RPORT(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#Initer,TRIGGER(a5)

	move.l	FrameCount(a5),d0
	add.l	#50,d0
.gey:	cmp.l	FrameCount(a5),d0
	bne.b	.gey


	lea	_custom,a6
	move.l	#movey,aud0+ac_ptr(a6)
	move.w	#6826/2,aud0+ac_len(a6)
	move.w	#1622,aud0+ac_per(a6)
	move.w	#64,aud0+ac_vol(a6)

	move.w	#%1000000000000001,dmacon(a6)

	move.l	FrameCount(a5),d0
	add.l	#152,d0
.gley:	cmp.l	FrameCount(a5),d0
	bne.b	.gley

	move.w	#%0000000000000001,dmacon(a6)
	move.w	#1,aud0+ac_len(a6)
	move.w	#0,aud0+ac_vol(a6)
	move.l	#Silence,aud0+ac_ptr(a6)


.lpt:	tst.b	TRIG_TEXT(a5)
	bne.b	.lpt




	; *** View picture
	move.l	animbuffer(a5),d0
	lea	bm_Planes(a0),a0
	lea	bplH8ptrs,a4
	moveq	#8-1,d7
.loop:	move.w	d0,6(a4)
	swap	d0
	move.w	d0,2(a4)
	swap	d0
	add.l	#40*256,d0
	addq.l	#8,a4
	dbra	d7,.loop

	bsr	Wait2f
	lea	_custom,a6
	move.l	#CopperlistH8,cop1lc(a6)


sanim1:
	btst.b	#6,$bfe001
	bne.b	sanim1

	bra	QuitNice


Wait2f:
	move.l	FrameCount(a5),d0
	add.l	#2,d0
.hey:	cmp.l	FrameCount(a5),d0
	bne.b	.hey
	rts


CarlText:
	move.l	a5,-(a7)

	tst.b	tempstop
	bne	EndAll

	bsr	swapscreen
	bsr	doletter
	bsr	dovector
	bsr	del

	move.l	(a7)+,a5
	rts


EndAll:
	sub.b	#1,waiter
	bne.b	.nof

	move.b	#10,waiter

	lea	ncmsb,a0
	move.w	2(a0),d0

	sub.w	#$0111,d0
	bmi.b	.done
	move.w	d0,2(a0)

.nof:	move.l	(a7)+,a5
	rts

.done:
	move.l	#Empty,TRIGGERH(a5)

	moveq	#0,d0
	moveq	#0,d1
	move.l	TEXT_RPORT(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOMove(a6)

	move.l	TEXT_RPORT(a5),a1
	jsr	_LVOClearScreen(a6)

	lea	NormCol,a0
;	move.w	#$0000,2(a0)
;	move.w	#$0558,6(a0)
	move.w	#$0fff,10(a0)
	move.w	#$0fff,14(a0)
	move.w	#$0fff,18(a0)
	move.w	#$0fff,22(a0)
	move.w	#$0fff,22(a0)
	move.w	#$0fff,26(a0)

	clr.b	Fader_Done(a5)
	move.l	#SFader,TRIGGER2(a5)

	; kludges unlimited:
;	move.l	(a7),a5
;	move.l	textbmap(a5),a0
;	lea	bm_Planes(a0),a0
;	move.l	a1,(a0)

	lea	NormPtrs,a0
	lea	Background,a1
	move.l	a1,d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)



	move.b	#1,stop

	move.l	(a7)+,a5
	rts

waiter:	dc.b	10
	cnop	0,4

FixSize:
	movem.l	d0/d1/d6/d7/a0/a1,-(a7)

	move.l	tracebuffer(a5),a0
	move.l	tracebuffer2(a5),a1
	move.l	#(170*256*3),d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOCopyMemQuick(a6)
	
	move.l	tracebuffer(a5),a0
	move.l	tracebuffer2(a5),a1

	move.w	#200,d6

.hey:	move.w	#75-1,d7
.lp:	clr.b	(a0)+
	clr.b	(a0)+
	clr.b	(a0)+
	dbra	d7,.lp

	move.w	#170-1,d7
.in:	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	dbra	d7,.in

	move.w	#75-1,d7
.lp2:	clr.b	(a0)+
	clr.b	(a0)+
	clr.b	(a0)+
	dbra	d7,.lp2

	dbra	d6,.hey

	movem.l	(a7)+,d0/d1/d6/d7/a0/a1
	rts

;---------------------------------
;- Dual Buffering For The Screen -
;---------------------------------
swapscreen:
	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0

	move.l	(a0),a2
	move.l	12(a0),a3
	move.l	a3,(a0)
	move.l	a2,12(a0)

	move.l	a3,screenP

	lea	NormPtrs,a0
	move.l	a3,d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)
	rts

;------------------
;- Do The Letters -
;------------------
doletter:
	tst.w	waitc
	beq	.draw
	rts

.draw:	lea oyep,a0
	move.w	zoomend,d0
	cmp.w	(a0),d0
	beq	.switch
	move.w	zoomspeed,d0
	add.w	d0,(a0)
	rts

.switch:
	lea	oyep,a0
	move.w	zoomstart,(a0)		; set new zoomvalue
	
	move.l	step,d0
	move.l	#letterPointer,a0
	add.l	d0,a0
	move.l	(a0),a0
	
	lea	partdo,a1		; get right part
	add.w	(a1),a0			; 
	cmp.w	#$ffff,(a0)		; finished the parts
	beq	.out			; new letter
	add.w	(a0),a0			;
	add.w	#2,partdo		; next part next time

; we have right part
	move.w	(a0)+,d0		; nr of points
	move.w	(a0)+,d1		; nr of lines
	move.w	d0,pnr			; points in pnr
	move.w	d1,lnr			; lines in lnr

	lea	vectors,a1
	moveq	#0,d2
	move.w	d0,d2			; nr of repeats
	mulu	#3,d2			; 3 times pr point
	sub.w	#1,d2
.loop:
	move.w	(a0)+,(a1)+
	dbra	d2,.loop

	move.w	d1,d2			; nr of words to lines
	lsl.w	#1,d2			; 2 times pr line
	sub.w	#1,d2
	lea	lines,a1
.loop2:
	move.w	(a0)+,(a1)+
	dbra	d2,.loop2
	rts
.out:					; next letter
	add.l	#4,step
	cmp.l	#4,step
	bne	.normal
	move.w	#7000,zoomstart
	move.w	#16000,zoomend
	move.w	#16000,oyep
	move.w	#200,zoomspeed
	move.w	#60,xval
	move.w	#150,yval
	move.w	#0,partdo
	bra	.switch
	rts
.normal:
	cmp.l	#36,step
	beq	.stop
	move.w	#0,partdo
	add.w	#30,xval
	moveq	#0,d0
	bra	.switch
	rts
.stop:
	move.w	#wait,waitc
	rts
dovector:
	tst.w	waitc
	bne	.out
	bsr	clearscreen
	bsr	calcvectors
	bsr	draw
.out:
	rts
;-------------------
;- Delete And Wait -
;-------------------
del:
	tst.w	waitc
	beq	.out
	cmp.w	#1,waitc
	beq	.delete
	sub.w	#1,waitc
.out:
	rts
.delete:
	move.b	#1,tempstop
	move.b	#1,pr_Enable
	rts

;---------------
;- Draw Object -
;---------------
draw:
	bsr.w	initlinedraw
	move.w	lnr,d7
	sub.w	#1,d7
	lea.l	lines(pc),a3
	lea.l	coords(pc),a4
drawloop:
	movem.w	(a3)+,d4-d5
	lsl.w	#2,d4
	lsl.w	#2,d5
	move.w	(a4,d4.w),d0
	move.w	2(a4,d4.w),d1
	move.w	(a4,d5.w),d2
	move.w	2(a4,d5.w),d3
	bsr.w	linedraw
	dbra	d7,drawloop
	rts
;--------------------
;- Clear The Screen -
;--------------------
clearscreen:
	btst	#6,$dff002
	bne.s	clearscreen
	move.l	screenP,d0
	add.l	#800,d0
	move.l	d0,$dff054
	move.l	#$01000000,$dff040
	move.w	#0,$dff066
	move.w	#200*64+20,$dff058

;	move.l	screenP(pc),a0
;	move.w	#(10240/4)-1,d0
;.loop:	clr.l	(a0)+
;	dbra	d0,.loop


	rts
;-----------------------
;- The Vector Routine  -
;- Rotates Coordinates -
;- Draw Vectors        -
;-----------------------
calcvectors:
	move.l	rxs,d0
	add.l	d0,rxl
	move.l	rys,d0
	add.l	d0,ryl
	move.l	rzs,d0
	add.l	d0,rzl
	
	move.w	#2046,d0
	move	rxl,rx
	and	d0,rx
	move	ryl,ry
	and	d0,ry
	move	rzl,rz
	and	d0,rz

	move.l	a5,-(a7)
	lea	vectors,a5
clcd_loop:
	move	(a5)+,d0	;x-coord
	move	(a5)+,d1	;y-coord
	move	(a5)+,d2	;z-coord
	
	move	rx,d3		;x-rotation
	move	ry,d4		;y-rotation
	move	rz,d5		;z-rotation
		
	lea	coords,a2
	move.w	pnr,d7
	sub.w	#1,d7
calcloop:
	bsr	rotate		;Give Coords (d0,d1) and z-d2

	move.w	d0,(a2)+
	move.w	d1,(a2)+
	move.w	(a5)+,d0	;x-coord
	move.w	(a5)+,d1	;y-coord
	move.w	(a5)+,d2	;z-coord
	move.w	rx,d3		;x-rotation
	move.w	ry,d4		;y-rotation
	move.w	rz,d5		;z-rotation
	dbra	d7,calcloop
	move.l	(a7)+,a5
	rts
;-------------------------------
;-      Line Draw Routine      -
;- Inizalize with linedrawinit -
;-     Call with linedraw      -
;-       a0 - screen           -  
;-       d0 - x1   d2 - x2     -
;-       d1 - y1   d3 - y2     -
;-------------------------------
linedraw:
	cmp.w	d0,d2
	bne.s	ld_not1pix
	cmp.w	d1,d3
	bne.s	ld_not1pix
	rts
ld_not1pix:
	movem.l	d4/d7/a3-a4,-(a7)
	moveq	#0,d7
	sub.w	d0,d2
	bge.s	ld_xok
	neg.w	d2
	addq.w	#2,d7
ld_xok:
	sub.w	d1,d3
	bge.s	ld_yok
	neg.w	d3
	addq.w	#4,d7
ld_yok:
	cmp.w	d3,d2
	bgt.s	ld_xyok
	bne.s	ld_not45
	add.w	#16,d7
ld_not45:
	exg	d2,d3
	addq.w	#8,d7
ld_xyok:
	add.w	d3,d3
	move.w	d3,d4
	sub.w	d2,d4
	add.w	d3,d3
	move.w	d3,a3
	add.w	d2,d2
	add.w	d2,d2
	sub.w	d2,d3
	mulu	#width,d1
	move.l	a0,a4
	add.w	d1,a4
	move.w	d0,d1
	lsr.w	#3,d1
	add.w	d1,a4
	andi.w	#$f,d0
	ror.w	#4,d0
	add.w	#$bc8,d0
	swap	d0
	move.w	(a1,d7.w),d0
	lsl.w	#4,d2
	addq.w	#2,d2
ld_wldraw:
	btst	#6,$2(a2)
	bne.s	ld_wldraw
	move.l	d0,$40(a2)
	move.w	d3,$64(a2)
	move.w	a3,$62(a2)
	move.w	d4,$52(a2)
	move.l	a4,$48(a2)
	move.l	a4,$54(a2)
	move.w	d2,$58(a2)
	movem.l	(a7)+,d4/d7/a3-a4
	rts

initlinedraw:
	move.l	screenP,a0
	move.w	zoomend,d0
	cmp.w	oyep,d0		; next plane if finished zoom
	bne	.goon

	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0
	move.l	4(a0),a0
;	add.l	#10240,a0
.goon:
	lea	octant,a1
	move.l	#$dff000,a2
waitinit:
	btst	#6,$2(a2)
	bne.s	waitinit
	move.l	#-1,$44(a2)
	move.l	#$ffff8000,$72(a2)
	move.w	#width,$60(a2)
	move.w	#width,$66(a2)
	rts
octant:
	dc.w	$0051,$0055,$0059,$005d
	dc.w	$0041,$0049,$0045,$004d
	dc.w	$0011,$0015,$0019,$001d
	dc.w	$0001,$0009,$0005,$000d
;---------------------------------------------------
;-        Rotates Coordnates (d0,d1,d2)            -
;- Returns With Perspective (d0,d1), Z-Value in d2 -
;-      Give Rotation by d3=rx, d4=ry, d5=rz       - 
;---------------------------------------------------
;oyep=1000
;oyep2=1000*65536/4
rotate:
	lea	SinusTable,a4
	lea	CosinusTable,a3
;	lea	SinusTable,a4
;	lea	CosinusTable,a3
	move	(a3,d3.w),cosx
	move	(a4,d3.w),sinx
	move	(a3,d4.w),cosy
	move	(a4,d4.w),siny
	move	(a3,d5.w),cosz
	move	(a4,d5.w),sinz
;	x1=x*cosz - y*sinz
;	y1=x*sinz + y*cosz
	move	sinz,d6
	move	cosz,d5
	move	d5,d3
	muls	d0,d3
	move	d6,d4
	muls	d1,d4
	sub.l	d4,d3
	asl.l	#2,d3
	swap	d3
	muls	d6,d0
	muls	d5,d1
	add.l	d0,d1
	asl.l	#2,d1
	swap	d1
;	x2=x1*cosy + z*siny
;	z2=-x1*siny + z*cosy
	move	siny,d6
	move	cosy,d5
	move	d5,d0
	muls	d3,d0
	move	d6,d4
	muls	d2,d4
	add.l	d4,d0
	asl.l	#2,d0
	swap	d0
	muls	d5,d2
	muls	d6,d3
	sub.l	d3,d2
	asl.l	#2,d2
	swap	d2
;	y3=y1*cosx - z2*sinx
;	z3=y1*sinx + z2*cosx
	move	sinx,d6
	move	cosx,d5
	move	d5,d3
	muls	d1,d3
	move	d6,d4
	muls	d2,d4
 	sub.l	d4,d3
	asl.l	#2,d3
	swap	d3
	muls	d6,d1
	muls	d5,d2
	add.l	d1,d2
	asl.l	#2,d2
	swap	d2
	move	oyep,d6
	add	d2,d6
	move.l	oyep2,d1
	divu	d6,d1
	muls	d1,d0
	swap	d0
	muls	d3,d1
	swap	d1
	add.w	xval,d0	;Center koordinates
	add.w	yval,d1 ;--------"-- ------
; Return rotated koordinates in (d0,d1,d2)
	rts

;---------------------
;- OBJECTS - OBJECTS -
;---------------------
vectors:	dcb.w	100,0
lines:	dcb.w	100,0	;	dc.w	0,1,2,3,4,5,5,6,7,8
coords:	dcb.l	100,0
;-----------------------------
;- Variables And Contestants -
;-----------------------------
textP:
	dc.l	0
letterPointer:
	dc.l	letterTRI
	dc.l	letterS,letterO,letterF,letterT,letterW
	dc.l	letterA,letterR,letterE
partdo:
	dc.w	0

letterTRI:
	dc.w	42,60,78,106,124,142,160,188,216,244
	dc.w	282,320,358,376,404,432,450,468,496,534
	dc.w	$ffff
;part1
	dc.w	2,1
	dc.w	-1515,-290,0
	dc.w	-705,-290,0
	dc.w	0,1
;part2
	dc.w	2,1
	dc.w	-1275,290,0
	dc.w	-1275,-170,0
	dc.w	0,1
;part3
	dc.w	3,2
	dc.w	-1105,290,0
	dc.w	-1105,0,0
	dc.w	-1025,-80,0
	dc.w	0,1,1,2

;part4
	dc.w	2,1
	dc.w	-985,20,0
	dc.w	-795,-170,0
	dc.w	0,1
;part5
	dc.w	2,1
	dc.w	-795,20,0
	dc.w	-685,20,0
	dc.w	0,1	
;part6
	dc.w	2,1
	dc.w	-725,290,0
	dc.w	-725,130,0
	dc.w	0,1
;part7
	dc.w	3,2
	dc.w	-545,-210,0
	dc.w	-545,-290,0
	dc.w	-465,-290,0
	dc.w	0,1,1,2	
;part8
	dc.w	3,2
	dc.w	-545,290,0
	dc.w	-545,-70,0
	dc.w	-455,-160,0
	dc.w	0,1,1,2				
;part9
	dc.w	3,2
	dc.w	-365,210,0
	dc.w	-365,-290,0
	dc.w	-275,-290,0
	dc.w	0,1,1,2
;part10
	dc.w	4,3
	dc.w	-255,190,0
	dc.w	-155,190,0
	dc.w	-155,-290,0
	dc.w	-65,-290,0
	dc.w	0,1,1,2,2,3
;part11
	dc.w	4,3
	dc.w	25,290,0
	dc.w	25,-230,0
	dc.w	85,-290,0
	dc.w	245,-290,0
	dc.w	0,1,1,2,2,3			
;part12
	dc.w	4,3
	dc.w	205,40,0
	dc.w	205,-120,0
	dc.w	375,-290,0
	dc.w	505,-290,0
	dc.w	0,1,1,2,2,3
;part13
	dc.w	2,1
	dc.w	475,340,0
	dc.w	475,-180,0
	dc.w	0,1
;part14
	dc.w	3,2
	dc.w	645,-200,0
	dc.w	645,-290,0
	dc.w	1055,-290,0		
	dc.w	0,1,1,2
;part15
	dc.w	3,2
	dc.w	655,290,0
	dc.w	655,10,0
	dc.w	745,-80,0
	dc.w	0,1,1,2
;part16
	dc.w	2,1
	dc.w	765,30,0
	dc.w	975,-180,0
	dc.w	0,1
;part17
	dc.w	2,1
	dc.w	1175,-290,0
	dc.w	1255,-290,0
	dc.w	0,1			
;part18
	dc.w	3,2
	dc.w	1165,290,0
	dc.w	1165,-100,0
	dc.w	1255,-190,0
	dc.w	0,1,1,2
;part19
	dc.w	4,3
	dc.w	1275,-70,0
	dc.w	1425,-70,0
	dc.w	1425,-290,0
	dc.w	1515,-290,0
	dc.w	0,1,1,2,2,3	
;part20
	dc.w	2,1
	dc.w	1425,190,0
	dc.w	1425,40,0
	dc.w	0,1


letterA:
	dc.w	8,36,64,$ffff
;part1
	dc.w	3,2
	dc.w	-200,-350,0
	dc.w	-200,-640,0
	dc.w	100,-950,0
	dc.w	0,1,1,2
;part2
	dc.w	3,2
	dc.w	300,1050,0
	dc.w	800,1050,0
	dc.w	800,-1050,0
	dc.w	0,1,1,2
;part3
	dc.w	4,3
	dc.w	-800,1050,0
	dc.w	-200,1050,0
	dc.w	-200,-150,0
	dc.w	100,-150,0
	dc.w	0,1,1,2,2,3

letterE:
	dc.w	10,38,66,94,$ffff
;part1
	dc.w	3,2
	dc.w	-200,-350,0
	dc.w	-200,-550,0
	dc.w	100,-950,0
	dc.w	0,1,1,2
;part2
	dc.w	3,2
	dc.w	300,-350,0
	dc.w	800,-350,0
	dc.w	800,-1050,0
	dc.w	0,1,1,2
;part3
	dc.w	3,2
	dc.w	-800,1050,0
	dc.w	800,1050,0
	dc.w	800,350,0
	dc.w	0,1,1,2
;part4			
	dc.w	3,2
	dc.w	-200,650,0
	dc.w	-200,-150,0
	dc.w	100,-150,0
	dc.w	0,1,1,2
letterF:
	dc.w	8,36,64,$ffff
;part1
	dc.w	3,2
	dc.w	-200,-350,0
	dc.w	-200,-550,0
	dc.w	100,-950,0
	dc.w	0,1,1,2
;part2
	dc.w	3,2
	dc.w	300,-350,0
	dc.w	800,-350,0
	dc.w	800,-1050,0
	dc.w	0,1,1,2
;part3
	dc.w	4,3
	dc.w	-800,1050,0
	dc.w	-200,1050,0
	dc.w	-200,150,0
	dc.w	100,150,0
	dc.w	0,1,1,2,2,3	
letterO:
	dc.w	6,84,$ffff
;part1
	dc.w	8,7
	dc.w	-300,650,0
	dc.w	-300,-550,0
	dc.w	-200,-550,0
	dc.w	-200,-750,0
	dc.w	-100,-750,0
	dc.w	-100,-850,0
	dc.w	0,-950,0
	dc.w	0,-950,0
	dc.w	0,1,1,2,2,3,3,4,4,5,5,6,6,7

;part2
	dc.w	5,4
	dc.w	-800,1050,0
	dc.w	600,1050,0
	dc.w	600,950,0
	dc.w	700,950,0
	dc.w	700,-950,0				
	dc.w	0,1,1,2,2,3,3,4
letterR:
	dc.w	12,80,98,166,204,$ffff
;part1
	dc.w	7,6
	dc.w	-200,-350,0
	dc.w	-200,-650,0
	dc.w	-100,-750,0
	dc.w	0,-750,0
	dc.w	0,-850,0
	dc.w	100,-850,0
	dc.w	100,-950,0
	dc.w	0,1,1,2,2,3,3,4,4,5,5,6
;part2
	dc.w	2,1
	dc.w	800,-850,0
	dc.w	800,-1050,0
	dc.w	0,1
;part3
	dc.w	7,6
	dc.w	400,-250,0
	dc.w	600,-250,0
	dc.w	600,-350,0
	dc.w	700,-350,0
	dc.w	700,-550,0
	dc.w	800,-550,0
	dc.w	800,-650,0
	dc.w	0,1,1,2,2,3,3,4,4,5,5,6
;part4
	dc.w	4,3
	dc.w	400,1050,0
	dc.w	800,1050,0
	dc.w	800,150,0
	dc.w	700,50,0
	dc.w	0,1,1,2,2,3
;part5
	dc.w	4,3
	dc.w	-800,1050,0
	dc.w	-200,1050,0
	dc.w	-200,-150,0
	dc.w	0,-150,0			
	dc.w	0,1,1,2,2,3

letterS:
	dc.w	12,30,48,76,104,$ffff
;part1
	dc.w	2,1
	dc.w	-200,650,0
	dc.w	-200,950,0
	dc.w	0,1
;part2
	dc.w	2,1
	dc.w	-800,-150,0
	dc.w	0,-150,0
	dc.w	0,1
;part3
	dc.w	3,2
	dc.w	-200,-350,0
	dc.w	-200,-650,0
	dc.w	100,-950,0
	dc.w	0,1,1,2
;part4
	dc.w	3,2
	dc.w	300,-350,0
	dc.w	800,-350,0
	dc.w	800,-1050,0
	dc.w	0,1,1,2
;part5
	dc.w	4,3
	dc.w	-600,1050,0
	dc.w	800,1050,0
	dc.w	800,150,0
	dc.w	700,50,0
	dc.w	0,1,1,2,2,3					
letterT:
	dc.w	6,24,$ffff
;part1
	dc.w	2,1
	dc.w	-500,-150,0
	dc.w	-300,-350,0
	dc.w	0,1
;part2
	dc.w	4,3
	dc.w	-100,1050,0
	dc.w	300,1050,0
	dc.w	300,-850,0
	dc.w	500,-1050,0
	dc.w	0,1,1,2,2,3
		
letterW:
	dc.w	8,26,44,$ffff
;part1
	dc.w	2,1
	dc.w	-400,650,0
	dc.w	-400,-450,0
	dc.w	0,1
;part2
	dc.w	2,1
	dc.w	100,750,0
	dc.w	100,-950,0
	dc.w	0,1
;part3
	dc.w	3,2
	dc.w	-600,1050,0
	dc.w	800,1050,0
	dc.w	800,-1050,0		
	dc.w	0,1,1,2

xval:		dc.w	164
yval:		dc.w	80
pnr:		dc.w	0
lnr:		dc.w	0
cosx:		dc.w	0
sinx:		dc.w	0
cosy:		dc.w	0
siny:		dc.w	0
cosz:		dc.w	0
sinz:		dc.w	0			
rxl:		dc.l	0
ryl:		dc.l	0
rzl:		dc.l	0
rxs:		dc.w	0		;speed	- signed value
rys:		dc.w	0
rzs:		dc.w	0
rx:		dc.w	0
ry:		dc.w	0
rz:		dc.w	0
stop:		dc.b	0
tempstop:	dc.b	0
		even
delline:		dc.l	17600
waitc:		dc.w	0
zoomstart:	dc.w	2340
zoomend:		dc.w	2800
zoomspeed:	dc.w	20
oyep:		dc.w	2800
oyep2:		dc.l	1000*65536/4
step:		dc.l	0
screenP:		dc.l	0


WIDTH		equ	40
HIGH		equ	64
Xc		equ	WIDTH-8
Yc		equ	HIGH/2
planesize	equ	2560

CarlVec:
	move.l	a5,-(a7)

;	move.w	#$0fff,$dff180

	cmp.w	#20000,zoomval
	beq	out


	bsr.w	CVswapscreen
	bsr	CVmakecolors
	bsr	CVblitcube
	bsr	CVfade
	bsr.w	CVcls
	bsr	CVzoom
	bsr	CVzoomout
	bsr.w	CVcube
	bsr.w	CVfill
;	move.w	#$000f,$dff180
	move.l	(a7)+,a5
	rts


out:	move.b	#1,CVstop
	move.l	(a7)+,a5
	rts




;-------------------------
;- Initialize The Screen -
;-------------------------
CVStartup:

	move.l	bbsbmap(a5),a1
	lea	bm_Planes(a1),a1
	move.l	(a1),d1
;	move.l	#textscreen,d1
	lea	textbplcop+2,a2
	move.w	d1,4(a2)
	swap	d1
	move.w	d1,(a2)

	move.l	#screen,d1
	lea	bplcop+2,a2
	moveq	#2,d0
.bplloop:
	bsr	bplset
	dbra	d0,.bplloop

	move.l	#screen2,d1
	lea	bplcop2+2,a2
	moveq	#2,d0
.bplloop2:
	bsr	bplset
	dbra	d0,.bplloop2

	move.l	#screen,d1
	lea	bplcop3+2,a2
	moveq	#2,d0
.bplloop3:
	bsr	bplset
	dbra	d0,.bplloop3

	move.l	#screen2,d1
	lea	bplcop4+2,a2
	moveq	#2,d0
.bplloop4:
	bsr	bplset
	dbra	d0,.bplloop4

	bsr	initcopper

	rts
bplset:
	swap	d1
	move.w	d1,(a2)
	swap	d1
	move.w	d1,4(a2)
	addq.l	#8,a2
	add.l	#2560,d1
	rts

;------------------------------
;- Initalize the coppper list -
;------------------------------
initcopper:
	move.l	#firstrow,rowP
	move.w	#$2d00,d1
	bsr	first
	move.l	#secondrow,rowP
	bsr	second
	move.w	#$ad00,d1
	move.l	#thirdrow,rowP
	bsr	first
	move.l	#row4,rowP
	bsr	fourth
	rts
fourth:
	move.l	rowP,a0
	move.l	#62,d0
	move.w	#$ed00,d1
	moveq	#0,d2
.loop:
	move.w	d1,(a0)
	move.b	#$07,1(a0)
	add.w	#2,a0
	bsr	setregs
	move.w	d1,(a0)
	move.b	#$7f,1(a0)
	add.w	#2,a0
	bsr	setregs
	add.w	#$100,d1
	addq.l	#1,d2
	cmp.l	#19,d2
	bne	.notyet
	move.l	#$ffdffffe,(a0)+
.notyet:
	dbra	d0,.loop
	rts
second:
	move.l	rowP,a0
	move.l	#62,d0
	move.w	#$6d00,d1
.loop:
	move.w	d1,(a0)
	move.b	#$07,1(a0)
	add.w	#2,a0
	bsr	setregs
	move.w	d1,(a0)
	move.b	#$7f,1(a0)
	add.w	#2,a0
	bsr	setregs
	add.w	#$100,d1
	dbra	d0,.loop
	rts
first:
	move.l	rowP,a0
	move.l	#62,d0
.loop:
	move.w	d1,(a0)
	move.b	#$07,1(a0)
	add.w	#2,a0
	bsr	setregs
	move.w	d1,(a0)
	move.b	#$5f,1(a0)
	add.w	#2,a0
	bsr	setregs
	move.w	d1,(a0)
	move.b	#$a1,1(a0)
	add.w	#2,a0
	bsr	setregs
	add.w	#$100,d1
	dbra	d0,.loop
	rts
setregs:
	move.w	#$fffe,(a0)+
	move.l	#$01820000,(a0)+
	move.l	#$01840000,(a0)+
	move.l	#$01860000,(a0)+
	move.l	#$01880000,(a0)+
	move.l	#$018a0000,(a0)+
	move.l	#$018c0000,(a0)+
	rts

;-----------------------------------------
;- The Fade routine from white to colors -
;-----------------------------------------
CVfade:
	tst.b	times
	beq	.out1
	tst.b	time
	bne	.out

	move.l	#9,d5
	lea	basecolors1+30,a0
	lea	fadecolor,a1
.loop:
	bsr	CVfadeem
	add.l	#32,a0
	add.l	#2,a1
	dbra	d5,.loop

	sub.b	#1,times
	tst.b	times
	bne	.goon
	move.b	#1,startzoom
.goon:
	move.b	#10,time
.out:
	sub.b	#1,time
.out1:
	rts

CVfadeem:
	move.w	#%0000000000001111,d0
	moveq	#2,d1
	move.w	#$1,d4
.loop:
	move.w	(a0),d2
	move.w	(a1),d3
	and.w	d0,d2
	and.w	d0,d3
	cmp.w	d2,d3
	beq	.next
	sub.w	d4,(a0)
.next:
	lsl.w	#4,d4
	lsl.w	#4,d0
	dbra	d1,.loop
	rts
;-------------------------
;- Make Different Colors -
;-------------------------
CVmakecolors:
	moveq	#5,d0
	lea	colorbuffer,a1
	lea	colorstore,a0
.loop:
	move.w	(a1)+,a2
	add.w	a2,a2
	move.w	a2,(a0)+
	dbra	d0,.loop

	lea	basetable,a4
	move.l	#7,d1
.loop2:
	move.l	(a4)+,baseP				; firstrow
	bsr	CVgetcolors
	move.l	(a4)+,rowP
	move.l	(a4)+,addcolor
	clr.b	special
	bsr	setcolorsspecial
	dbra	d1,.loop2

	lea	lasttable,a4
	moveq	#1,d1
.loop3:
	move.l	(a4)+,baseP
	bsr	CVgetcolors
	move.l	(a4)+,rowP
	move.l	(a4)+,addcolor
	move.b	#1,special
	bsr	setcolorsspecial
	dbra	d1,.loop3
	rts
setcolorsspecial:
	move.l	rowP,a0
	move.l	colorP,a1
	move.l	#62,d0
.loop:
	add.w	#6,a0
	move.w	(a1)+,(a0)
	add.w	#4,a0
	move.w	(a1)+,(a0)
	add.w	#4,a0
	move.w	(a1)+,(a0)
	add.w	#4,a0
	move.w	(a1)+,(a0)
	add.w	#4,a0
	move.w	(a1)+,(a0)
	add.w	#4,a0
	move.w	(a1)+,(a0)
	add.w	#2,a0
	add.l	addcolor,a0
	move.l	colorP,a1
	tst.b	special
	beq	.not
	cmp.l	#44,d0
	bne	.not
	add.w	#4,a0
.not:
	dbra	d0,.loop
	rts
CVgetcolors:
	move.l	baseP,a1
	lea	colorstore,a2
	move.l	colorP,a3
	moveq	#5,d0
.getcolor:
	add.w	(a2),a1
	move.w	(a1),(a3)
	add.w	#2,a2
	add.w	#2,a3
	move.l	baseP,a1
	dbra	d0,.getcolor
	rts
;---------------
;- Get in cube -
;---------------
CVblitcube:
	move.l	bufferP,a0
	lea	screen,a1
	bsr	.waitblit
	lea	screen+16,a1
	bsr	.waitblit
	lea	screen+32,a1
	bsr	.waitblit
	lea	screen2+8,a1
	bsr	.waitblit
	lea	screen2+24,a1
.waitblit:
	btst	#6,$dff002
	bne	.waitblit
	move.l	#$09f00000,$dff040
	move.l	#-1,$dff044
	move.l	#$00200020,$dff064
	move.l	a0,$dff050
	move.l	a1,$dff054
	move.w	#192*64+4,$dff058
	rts
;------------------
;- Dual Buffering -
;------------------
CVswapscreen:
	move.l	bufferP,a0
	cmp.l	#cubebuffer,a0
	beq	.use_buffer2

	move.l	#cubebuffer2,d0
	move.l	#cubebuffer,bufferP
	rts
.use_buffer2:
	move.l	#cubebuffer,d0
	move.l	#cubebuffer2,bufferP
	rts
;----------------
;- Zoom Routine -
;----------------
CVzoom:
	cmp.b	#1,startzoom
	bne	.return
	cmp.w	#1650,zoomval
	beq.b	.return
	add.w	#10,zoomval
	cmp.w	#1650,zoomval
	bne	.return
	move.b	#2,rotz
	move.b	#1,rotx
	move.b	#1,roty
.return:
	rts
;--------------------
;- Zoom Out Routine -
;--------------------
CVzoomout:
	cmp.b	#2,startzoom
	bne	.return
	cmp.w	#20000,zoomval
	beq.b	.return
	add.w	#50,zoomval
.return:
	rts
;--------------------------
;- Fill And Clear Routine -
;--------------------------
CVfill:
	move.l	bufferP,d0
	add.l	#2560*2+2526,d0
.waitblit:
	btst	#6,$dff002
	bne.b	.waitblit
	move.l	d0,$dff050
	move.l	d0,$dff054
	move.l	#$00200020,$dff064
	move.l	#$09f0000a,$dff040
	move.w	#(3*64*64+4),$dff058
	rts
;--------------------
;- Clear The Screen -
;--------------------
CVcls:
	btst	#6,$dff002
	bne.b	CVcls
	move.l	bufferP,$dff050
	move.l	bufferP,$dff054
	move.w	#32,$dff066
	move.l	#$01000000,$dff040
	move.w	#(192*64+4),$dff058
	rts
;--------------------
;- The Line Routine -
;- d0-d3    (x1-y2) -
;- a0       screen  -
;--------------------
CVlineinit:
	btst	#6,$dff002
	bne.b	CVlineinit
	moveq	#-1,d0
	move.l	d0,$dff044
	move.w	#$8000,d0
	move.l	d0,$dff072
	rts
CVlinedraw:
	cmp.w	d1,d3
	bne.b	.line1
	rts
.line1:
	blt.s	.line2
	exg	d2,d0
	exg	d3,d1
.line2:
	addq.w	#1,d3
	moveq	#0,d4
	sub.w	d1,d3
	bpl.s	.line3
	neg.w	d3
	bra.b	.line4
.line3:
	ori.b	#1,d4
.line4:
	sub.w	d0,d2
	bpl.s	.line5
	neg.w	d2
	bra.b	.line6
.line5:
	ori.b	#2,d4
.line6:
	move.w	d2,d5
	sub.w	d3,d5
	bpl.s	.line7
	exg	d3,d2
	bra.b	.line8
.line7:
	ori.b	#4,d4
.line8:
	ror.w	#4,d0
	ori.w	#$0b00,d0
	moveq	#0,d5
	move.b	d0,d5
	add.w	d5,d5
	move.b	#$4a,d0
	mulu	#width,d1
	add.w	d5,d1
	add.w	d1,a0
	move.b	table(pc,d4.w),d4
	add.w	d3,d3
.waitblit:
	btst	#6,$dff002
	bne.b	.waitblit
	move.w	d3,$dff062
	sub.w	d2,d3
	bpl.s	.line9
	ori.b	#$42,d4
.line9:
	move.w	d4,$dff042
	move.l	d3,$dff050
	sub.w	d2,d3
	move.w	d3,$dff064
	move.w	d0,$dff040
	move.l	a0,$dff048
	move.l	a0,$dff054
	moveq	#WIDTH,d0
	move.w	d0,$dff060
	move.w	d0,$dff066
	asl.w	#6,d2
	add.w	#64+2,d2
	move.w	d2,$dff058
	rts
table:
	dc.b	15,11,07,03,31,23,27,19
;-------------------------  
;-   Rotation Routine    -
;- d0-d2	(x,y,z)  -
;- d3		sin      -
;- d4		cos      -
;- a0		sintable -
;-------------------------
CVrotation:
	lea	sinus,a0
	move.b	CVrz,d5
	bsr.s	.rotation1
	move.b	CVry,d5
	bsr.s	.rotation1
	move.b	CVrx,d5
.rotation1:
	bsr.b	.rotation2
	move.w	d6,d3
	add.b	#$40,d5
	bsr.b	.rotation2
	move.w	d6,d4
	move.w	d0,d5
	move.w	d1,d6
	muls	d4,d5
	muls	d3,d6
	add.l	d5,d6
	asr.l	#8,d6
	move.w	d0,d5
	move.w	d6,d0
	move.w	d1,d6
	muls	d3,d5
	muls	d4,d6
	sub.l	d5,d6
	asr.l	#8,d6
	move.w	d6,d1
	exg	d1,d2
	exg	d0,d1
	rts
.rotation2:
	move.b	d5,d6
	andi.w	#$007f,d6
	move.b	(a0,d6.w),d6
	tst.b	d5
	bpl.s	.rotation3
	neg.w	d6
.rotation3:
	rts
;------------------------
;-   Projction Routine  -
;- d0-d2	(x,y,z) -
;------------------------
CVprojection:
	move.w	#240,d3
	lea	zoomval,a0
	add.w	(a0),d2			; z+D
	ble.s	.projection1
	muls	d3,d0
	muls	d3,d1
	divs	d2,d0
	divs	d2,d1
	add.w	#Xc,d0	;center coordinates
	add.w	#Yc,d1	;-------""---------
.projection1:
	rts
;-----------------
;- Draw The Cube -
;-----------------
CVcube:
	lea	rotz,a0
	move.b	(a0),d1
	add.b	d1,CVrz
	lea	roty,a0
	move.b	(a0),d1
	add.b	d1,CVry
	lea	rotx,a0
	move.b	(a0),d1
	add.b	d1,CVrx

	movem.w	palette,d1/d2/d4
	moveq	#0,d0
	move.l	d2,d3
	move.l	d4,d5
	move.l	d4,d6
	move.l	d4,d7
	movem.w	d1-d7,colorbuffer
	lea	CVcoords,a1
	lea	points,a2
	move.l	a2,a3
	lea	Z,a4
	moveq	#7,d7
.cube1:
	move.b (a1)+,d0
	move.b (a1)+,d1
	move.b (a1)+,d2
	ext.w	d0
	ext.w	d1
	ext.w	d2
	bsr.w	CVrotation
	move.l	d2,(a4)+
	bsr.w	CVprojection
	movem.w	d0/d1,(a2)
	addq.w	#4,a2
	dbf	d7,.cube1
	pea	palette
	lea	faces,a1
	move.l	bufferP,a4
	moveq	#%01010100,d7
.cube2:
	lea	buffer,a0
	move.l	a0,a2
	moveq	#0,d0
	moveq	#4-1,d1
.cube3:
	move.b	(a1)+,d0
	move.l	(a3,d0.w),(a0)
	addq.w	#4,a0
	dbf	d1,.cube3
	move.l	(a2),(a0)
	movem.w	(a2),d0-d5
	sub.w	d0,d2
	sub.w	d0,d4
	sub.w	d1,d3
	sub.w	d1,d5
	muls	d5,d2
	muls	d4,d3
	sub.l	d2,d3
	ble.b	.cube6
	lea	Z,a0
	moveq	#0,d2
	move.b	-1(a1),d2
	move.l	(a0,d2.w),d0
	move.b	-3(a1),d2
	move.l	(a0,d2.w),d1
	add.w	d1,d0
	bge.b	.cube4
	neg.w	d0
.cube4:
	lsr.w	#4,d0
	move.l	(sp),a0
	move.w	d0,(a0)
	bsr.w	CVlineinit
	moveq	#4-1,d6
.cube5:
	movem.w	(a2),d0-d3
	move.l	a4,a0
	bsr.w	CVlinedraw		;draw the lines
	addq.w	#4,a2
	dbf	d6,.cube5
.cube6:
	add.b	d7,d7
	bcc.b	.cube7
	addq.l	#2,(sp)
	add.w	#planesize,a4		;next bitplane
.cube7:
	tst.b	d7
	bne.b	.cube2
	addq.l	#4,sp
	rts

;-----------------------
;- POINTERS AND VALUES -
;-----------------------
CVrx:		dc.b	0
CVry:		dc.b	0
CVrz:		dc.b	0
special:		dc.b	0
startclear:	dc.b	0
CVstop:		dc.b	0
newline:		dc.b	0
cursormove:	dc.b	0
cursortime:	dc.b	0
time:		dc.b	0
startzoom:	dc.b	0
waitupdate:	dc.b	0
rotz:		dc.b	0
roty:		dc.b	0
rotx:		dc.b	0		
	even
cursoradd:	dc.l	0
screenadd:	dc.l	0
colortable:	dcb.w	8,0
colorstore:	dcb.w	8,0
palette:		dcb.w	3,0
colorbuffer:	dcb.w	8,0
Z:		dcb.l	8,0
points:		dcb.l	8,0
buffer:		dcb.l	5,0
cursorflash:	dc.b	1
times:		dc.b	15
		even
zoomval:		dc.w	1060
addcolor:	dc.l	56
cursorline:	dc.l	280
charlineadd:	dc.l	280
clearline:	dc.l	10200
CVcoords:
	dc.b	 126, 126,126
	dc.b	 126,-126,126
	dc.b	 126,-126,-126
	dc.b	 126,126,-126
	dc.b	-126,126,126
	dc.b	-126,-126,126
	dc.b	-126,-126,-126
	dc.b	-126,126,-126
faces:
	dc.b	0,4,8,12
	dc.b	20,16,28,24
	dc.b	0,12,28,16
	dc.b	8,4,20,24
	dc.b	0,16,20,4
	dc.b	28,12,8,24
	even

bufferP:	dc.l	screen
colorP:	dc.l	colortable
baseP:	dc.l	basecolors1
rowP:	dc.l	firstrow

fadecolor:
	dc.w	$0f70,$0f0f,$00ff,$0fd0,$00f0,$000f,$0fcc,$0cff,$0edf
	dc.w	$08fc
basecolors1:
	dc.w	$0000,$0100,$0210,$0310,$0420,$0520,$0630,$0730
	dc.w	$0840,$0940,$0a50,$0b50,$0c60,$0d60,$0e70,$0fff
basecolors2:
	dc.w	$0000,$0100,$0202,$0303,$0404,$0505,$0606,$0707
	dc.w	$0808,$0909,$0a0a,$0b0b,$0c0c,$0d0d,$0e0e,$0fff
basecolors3:
	dc.w	$0000,$0011,$0022,$0033,$0044,$0055,$0066,$0077
	dc.w	$0088,$0099,$00aa,$00bb,$00cc,$00dd,$00ee,$0fff
basecolors4:
	dc.w	$0000,$0110,$0210,$0310,$0420,$0530,$0640,$0750
	dc.w	$0860,$0970,$0a80,$0b90,$0ca0,$0db0,$0ec0,$0fff
basecolors5:
	dc.w	$0000,$0010,$0020,$0030,$0040,$0050,$0060,$0070
	dc.w	$0080,$0090,$00a0,$00b0,$00c0,$00d0,$00e0,$0fff
basecolors6:
	dc.w	$0000,$0001,$0002,$0003,$0004,$0005,$0006,$0007
	dc.w	$0008,$0009,$000a,$000b,$000c,$000d,$000e,$0fff
basecolors7:
	dc.w	$0000,$0100,$0211,$0311,$0422,$0533,$0644,$0744
	dc.w	$0855,$0966,$0a77,$0b88,$0c99,$0daa,$0ebb,$0fff
basecolors8:
	dc.w	$0000,$0011,$0122,$0233,$0244,$0355,$0366,$0477
	dc.w	$0588,$0699,$07aa,$08bb,$09cc,$0add,$0bee,$0fff
basecolors9:
	dc.w	$0000,$0103,$0214,$0325,$0436,$0547,$0658,$0769
	dc.w	$087a,$098b,$0a9c,$0bad,$0cbe,$0dcf,$0ddf,$0fff
basecolors10:
	dc.w	$0000,$0010,$0021,$0032,$0043,$0054,$0164,$0175
	dc.w	$0286,$0396,$03a7,$04b8,$05c9,$06da,$07eb,$0fff
basetable:
	dc.l	basecolors1,firstrow,56
	dc.l	basecolors2,firstrow+28,56
	dc.l	basecolors3,firstrow+56,56
	dc.l	basecolors4,secondrow,28
	dc.l	basecolors5,secondrow+28,28
	dc.l	basecolors6,thirdrow,56
	dc.l	basecolors7,thirdrow+28,56
	dc.l	basecolors8,thirdrow+56,56
lasttable:
	dc.l	basecolors9,row4,28
	dc.l	basecolors10,row4+28,28

sinus:	incbin	"sintable"




; *******************************************************************
; C24toH8:
; Converts a 24 bit stream to a Ham 8 chunky stream, based on a
; square 4x4x4 palette.
; *******************************************************************

; a2 = h8c dest buffer
; a3 = rgb source buffer
; d7 = height - 1


C24toH8:
;	lea	chunkybuffer(a5),a2

	move.l	d7,-(a7)
.l1:	move.l	#320-1,d6


	; *** new line
	clr.b	oldr(a5)
	clr.b	oldg(a5)
	clr.b	oldb(a5)

	; *** new pixel
.l2:	moveq	#0,d0
	move.w	d0,d1
	move.w	d0,d2
	move.w	d0,d3
	move.w	d0,d4
	move.w	d0,d5


	; *** Find color with biggest error
	move.b	(a3),d0
	move.b	1(a3),d1
	move.b	2(a3),d2

	sub.b	oldr(a5),d0
	sub.b	oldg(a5),d1
	sub.b	oldb(a5),d2

	tst.b	d0
	bpl.b	.nd1
	neg.b	d0
.nd1:	tst.b	d1
	bpl.b	.nd2
	neg.b	d1
.nd2:	tst.b	d2
	bpl.b	.nd3
	neg.b	d2

.nd3:	cmp.b	d1,d0
	bhi.b	.chd2

	; d0 < d1
	cmp.b	d2,d1
	bhi.b	.d1big

	cmp.b	d2,d0
	bhi.b	.d0big

.d2big:	bsr	FixBlue
	bra.b	.setit

	; d0 > d1
.chd2:	cmp.b	d2,d0
	bhi.b	.d0big

	cmp.b	d1,d2
	bhi.b	.d2big

.d1big:	bsr	FixGreen
	bra.b	.setit

.d0big:	bsr	FixRed

	; d0 = value
.setit:
	move.b	d0,(a2)+
	add.w	#3,a3

	dbra	d6,.l2

	dbra	d7,.l1

	; *** conversion done, now do c2p
	move.l	(a7)+,d3

	; *** old code
;	move.b	#1,gfxlock		; kludges, here we go again..

;	moveq	#0,d0
;	move.w	d0,d1
;	move.w	#319,d2
;	move.l	a4,a0
;	lea	backupport(a5),a1
;	lea	chunkybuffer(a5),a2
;	move.l	_GfxBase(a5),a6
;	jsr	_LVOWritePixelArray8(a6)

;	clr.b	gfxlock

	rts

gfxlock:	dc.b	0
	cnop	0,4

	; *** Red had biggest error, check if ham applies
FixRed:
	move.b	(a3),d3
	move.b	oldg(a5),d4
	move.b	oldb(a5),d5

	; t = d0/d1/d2
	; best 1 reg change = d3/d4/d5

	and.b	#%11111100,d3		; cut to 6 bit

	; t = close(c1)
	move.b	d3,d0
	and.b	#%11000000,d0

	move.b	1(a3),d1
	and.b	#%11000000,d1

	move.b	2(a3),d2
	and.b	#%11000000,d2


	; check sq. error
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5

	muls.w	d3,d3
	muls.w	d4,d4
	muls.w	d5,d5

	add.w	d4,d3
	add.w	d5,d3

	; d3 = squared error

	cmp.w	#11907,d3
	bhi.b	.setcl

	; sq < 11907, use ham

	move.b	(a3),d0
	and.b	#%11111100,d0
	move.b	d0,oldr(a5)
	or.b	#%00000010,d0		; ham red change
	rts

	; squared error too big, use palette value
.setcl:
	move.b	(a3),d0
	and.b	#%11000000,d0
	move.b	d0,oldr(a5)

	move.b	1(a3),d1
	and.b	#%11000000,d1
	move.b	d1,oldg(a5)
	lsr.b	#2,d1
	add.b	d1,d0

	move.b	2(a3),d1
	and.b	#%11000000,d1
	move.b	d1,oldb(a5)
	lsr.b	#4,d1
	add.b	d1,d0

	rts



FixGreen:
	move.b	oldr(a5),d3
	move.b	1(a3),d4
	move.b	oldb(a5),d5

	; t = d0/d1/d2
	; best 1 reg change = d3/d4/d5

	and.b	#%11111100,d4		; cut to 6 bit

	; t = close(c1)
	move.b	(a3),d0
	and.b	#%11000000,d0

	move.b	d4,d1
	and.b	#%11000000,d1

	move.b	2(a3),d2
	and.b	#%11000000,d2


	; check sq. error
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5

	muls.w	d3,d3
	muls.w	d4,d4
	muls.w	d5,d5

	add.w	d4,d3
	add.w	d5,d3

	; d3 = squared error

	cmp.w	#11907,d3
	bhi.b	.setcl

	; sq < 11907, use ham

	move.b	1(a3),d0
	and.b	#%11111100,d0
	move.b	d0,oldg(a5)
	or.b	#%00000011,d0		; ham green change
	rts

	; squared error too big, use palette value
.setcl:
	move.b	(a3),d0
	and.b	#%11000000,d0
	move.b	d0,oldr(a5)

	move.b	1(a3),d1
	and.b	#%11000000,d1
	move.b	d1,oldg(a5)
	lsr.b	#2,d1
	add.b	d1,d0

	move.b	2(a3),d1
	and.b	#%11000000,d1
	move.b	d1,oldb(a5)
	lsr.b	#4,d1
	add.b	d1,d0

	rts





FixBlue:
	move.b	oldr(a5),d3
	move.b	oldg(a5),d4
	move.b	2(a3),d5

	; t = d0/d1/d2
	; best 1 reg change = d3/d4/d5

	and.b	#%11111100,d5		; cut to 6 bit

	; t = close(c1)
	move.b	(a3),d0
	and.b	#%11000000,d0

	move.b	1(a3),d1
	and.b	#%11000000,d1

	move.b	d5,d2
	and.b	#%11000000,d2


	; check sq. error
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5

	muls.w	d3,d3
	muls.w	d4,d4
	muls.w	d5,d5

	add.w	d4,d3
	add.w	d5,d3

	; d3 = squared error

	cmp.w	#11907,d3
	bhi.b	.setcl

	; sq < 11907, use ham

	move.b	2(a3),d0
	and.b	#%11111100,d0
	move.b	d0,oldb(a5)
	or.b	#%00000001,d0		; ham blue change
	rts

	; squared error too big, use palette value
.setcl:
	move.b	(a3),d0
	and.b	#%11000000,d0
	move.b	d0,oldr(a5)

	move.b	1(a3),d1
	and.b	#%11000000,d1
	move.b	d1,oldg(a5)
	lsr.b	#2,d1
	add.b	d1,d0

	move.b	2(a3),d1
	and.b	#%11000000,d1
	move.b	d1,oldb(a5)
	lsr.b	#4,d1
	add.b	d1,d0

	rts





; ***************************************************************************
; VBHandler - main vb interrupt routine
; ***************************************************************************

VBHandler:
	movem.l	a0-a6/d0-d7,-(a7)

;.hh:	btst.b	#6,$bfe001
;	beq.b	.hh


	; *** play music
	bsr	pr_music

	move.l	HARDBASE(pc),a5

	addq.l	#1,FrameCount(a5)


	; *** call current routine
	lea	_custom,a6

	tst.b	gfxlock
	bne.b	.nope

	move.l	TEXT_PTR(a5),a4
	move.l	TRIGGER(a5),a0
	jsr	(a0)
	move.l	a4,TEXT_PTR(a5)

.nope:
	move.l	TRIGGER2(a5),a0
	jsr	(a0)

	move.l	TRIGGERH(a5),a0
	jsr	(a0)

	tst.b	stop
	bne.b	.hey
	move.l	TRIGGERH(a5),a0
	jsr	(a0)

.hey	lea	_custom,a6
	move.w	#INTF_VERTB,intreq(a6)		; clear interrupt request
	movem.l	(a7)+,a0-a6/d0-d7

	rte

; ***************************************************************************
; Fader
; ***************************************************************************

Fader:
	lea	_custom,a6
	move.l	#NormCopper,cop1lc(a6)

	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0
	lea	NormPtrs,a3
	move.l	(a0),d0
	move.w	d0,6(a3)
	swap	d0
	move.w	d0,2(a3)

	move.w	#50,Fader_Steps(a5)
	move.l	#FaderFlash,TRIGGER2(a5)
	rts

FaderFlash:
	lea	NormCol,a0
	not.w	2(a0)

	sub.w	#1,Fader_Steps(a5)
	bne.b	.goon

	move.l	#IFader2,TRIGGER2(a5)

.goon:	rts


IFader2:
	move.w	#$0fff,Fader_lrgb(a5)
	move.w	#$0fff,Fader_mrgb(a5)
	lea	_custom,a6
	move.l	#NormCopper,cop1lc(a6)
	move.w	#255-1,Fader_Steps(a5)
	move.l	#Fader2,TRIGGER2(a5)

	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0
	lea	NormPtrs,a3
	move.l	(a0),d0
	move.w	d0,6(a3)
	swap	d0
	move.w	d0,2(a3)
;	rts

Fader2:	sub.w	#$0111,Fader_lrgb(a5)
	bpl.b	.skip
	sub.w	#$0111,Fader_mrgb(a5)
	bmi.b	.done
.skip:	lea	lsb,a0
	move.w	Fader_lrgb(a5),2(a0)
	lea	NormCol,a0
	move.w	Fader_mrgb(a5),2(a0)
	sub.w	#1,Fader_Steps(a5)
	beq.b	.done
	move.w	#2,Fader_Wait(a5)
	move.l	#FaderWait,TRIGGER2(a5)
	rts
.done:	move.b	#1,Fader_Done(a5)
	move.l	#Empty,TRIGGER2(a5)
	rts
FaderWait:
	sub.w	#1,Fader_Wait(a5)
	bne.b	.goon
	move.l	#Fader2,TRIGGER2(a5)
.goon:	rts




; ***************************************************************************
; SFader
; ***************************************************************************

SFader:
	move.w	#0,Fader_Steps(a5)
	move.w	#$0fff,Fader_mrgb(a5)
	move.l	#SFader2,TRIGGER2(a5)
	lea	_custom,a6
	move.l	#NormCopper,cop1lc(a6)
	lea	NormCol,a0
	move.w	#$0fff,2(a0)
	move.w	#$0fff,6(a0)

	lea	NormPtrs,a0
	lea	Background,a1
	move.l	a1,d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	rts
	
SFader2:	lea	NormCol,a0
	lea	ftab2(pc),a1

	move.w	Fader_mrgb(a5),2(a0)

	move.w	Fader_Steps(a5),d0
	move.w	(a1,d0*2),d0
	move.w	d0,6(a0)

	add.w	#1,Fader_Steps(a5)
	sub.w	#$0111,Fader_mrgb(a5)
	bpl.b	.skip

.done:	move.b	#1,Fader_Done(a5)
	move.l	#Empty,TRIGGER2(a5)
	rts

.skip:	move.w	#3,Fader_Wait(a5)
	move.l	#SFaderWait,TRIGGER2(a5)
	rts


SFaderWait:
	sub.w	#1,Fader_Wait(a5)
	bne.b	.goon
	move.l	#SFader2,TRIGGER2(a5)
.goon:	rts

ftab2:	dc.w	$0fff,$0eef,$0eee,$0dde,$0ccd,$0ccd,$0bbc,$0aac
	dc.w	$0aab,$099b,$088a,$088a,$0779,$0669,$0668,$0558


; ***************************************************************************
; Fader
; ***************************************************************************

FaderC:
	move.w	#$0fff,Fader_lrgb(a5)
	move.w	#$0fff,Fader_mrgb(a5)
	lea	_custom,a6
	move.l	#copper,cop1lc(a6)
	move.w	#255-1,Fader_Steps(a5)
	move.l	#Fader2C,TRIGGER2(a5)
	rts
Fader2C:	sub.w	#$0111,Fader_lrgb(a5)
	bpl.b	.skip
	sub.w	#$0111,Fader_mrgb(a5)
	bmi.b	.done
.skip:	lea	coplsb,a0
	move.w	Fader_lrgb(a5),2(a0)
	lea	copmsb,a0
	move.w	Fader_mrgb(a5),2(a0)
	sub.w	#1,Fader_Steps(a5)
	beq.b	.done
	move.w	#2,Fader_Wait(a5)
	move.l	#FaderCWait,TRIGGER2(a5)
	rts
.done:	move.b	#1,Fader_Done(a5)
	move.l	#Empty,TRIGGER2(a5)
	rts
FaderCWait:
	sub.w	#1,Fader_Wait(a5)
	bne.b	.goon
	move.l	#Fader2C,TRIGGER2(a5)
.goon:	rts

; ***************************************************************************
; Current routine handlers
; ***************************************************************************

;(Initer-(NewLiner-(DrawLetter-Waiter1)*-EndLiner-Waiter2)*-Clearer-Specialer-Waiter3)*

Initer:
	tst.b	stop
	bne.b	.doit

	rts

.doit:	moveq	#0,d3
	move.w	(a4)+,d0			; v center
	move.w	(a4)+,d3			; lines

	move.w	d3,initer_lines(a5)

	move.w	d0,initer_vcenter(a5)
	bne.b	.i_noh


	; *** use v centering
	moveq	#127,d2
	move.l	TEXT_RPORT(a5),a0

	move.w	rp_TxHeight(a0),d4
	lsr.w	#1,d4
	add.w	d4,d2

	mulu	d4,d3
	sub.w	d3,d2
	move.w	d2,ybase(a5)
	bra.b	.i_lns

.i_noh:	move.w	d0,ybase(a5)

.i_lns:
;	bra	NewLiner


NewLiner:
	move.l	(a4)+,a0
	move.b	(a4)+,d2			; center horiz
	move.b	(a4)+,nl_llwait(a5)	; lineletterwait
	move.b	(a4)+,nl_color(a5)
	addq.l	#1,a4			; hmm

	move.b	(a0)+,nl_letters(a5)
	move.l	a0,nl_curtxt(a5)

	move.b	d2,nl_hcenter(a5)

	cmp.b	#2,d2
	beq.b	.nl_lt

	cmp.b	#1,d2
	beq.b	.nl_ct

	; *** 3 = right justify
	move.l	_GfxBase(a5),a6
	move.l	TEXT_RPORT(a5),a1
	move.l	nl_curtxt(a5),a0
	moveq	#0,d0
	move.b	nl_letters(a5),d0
	jsr	_LVOTextLength(a6)

	move.l	#320,d1
	sub.l	d0,d1
	move.w	d1,xbase(a5)

	bra.b	.mov

	; *** 2 = left justify
.nl_lt:	clr.w	xbase(a5)
	bra.b	.mov

	; *** 1 = center
.nl_ct:	move.l	_GfxBase(a5),a6
	move.l	TEXT_RPORT(a5),a1
	move.l	nl_curtxt(a5),a0
	moveq	#0,d0
	move.b	nl_letters(a5),d0
	jsr	_LVOTextLength(a6)

	lsr.l	#1,d0
	move.l	#160,d1
	sub.l	d0,d1
	move.w	d1,xbase(a5)

.mov:	move.w	xbase(a5),d0
	move.w	ybase(a5),d1
	move.l	TEXT_RPORT(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOMove(a6)

	move.l	TEXT_RPORT(a5),a1
	move.b	nl_color(a5),d0
	jsr	_LVOSetAPen(a6)


;	bra	DrawLetter


DrawLetter:
	move.l	_GfxBase(a5),a6

	tst.b	nl_llwait(a5)
	bne.b	.norm

	; *** draw entire line
.pat:	moveq	#0,d0
	move.b	nl_letters(a5),d0
	move.l	TEXT_RPORT(a5),a1
	move.l	nl_curtxt(a5),a0
	jsr	_LVOText(a6)

	bra	EndLiner

	; *** draw one letter
.norm:	subq.b	#1,nl_letters(a5)
	move.l	TEXT_RPORT(a5),a1
	move.l	nl_curtxt(a5),a0
	moveq	#1,d0
	jsr	_LVOText(a6)

.owait:	move.b	nl_llwait(a5),w1_wait(a5)
	addq.l	#1,nl_curtxt(a5)

;	bra	Waiter1

Waiter1:
	move.l	#Waiter1,TRIGGER(a5)

	subq.b	#1,w1_wait(a5)
	bne.b	.no

	tst.b	nl_letters(a5)
	bne.b	.goon

	; *** end of line, parse new
	move.l	#EndLiner,TRIGGER(a5)
	rts

.goon:	move.l	#DrawLetter,TRIGGER(a5)

.no:	rts


EndLiner:
	move.l	TEXT_RPORT(a5),a0
	move.w	rp_TxHeight(a0),d0
	add.w	d0,ybase(a5)

	move.w	(a4)+,w2_wait(a5)

	tst.w	w2_wait(a5)
	bne.b	.carryon

	subq.w	#1,initer_lines(a5)
	beq.b	W2_end			; kludge

.hh	bra	NewLiner


.carryon:
	move.l	#Waiter2,TRIGGER(a5)

	rts


Empty:	rts

Waiter2:
	move.l	#Waiter2,TRIGGER(a5)

	subq.w	#1,w2_wait(a5)
	beq.b	.no2

	rts

.no2	subq.w	#1,initer_lines(a5)
	beq.b	W2_end

	move.l	#NewLiner,TRIGGER(a5)
	rts

W2_end:	move.w	#(256/4)-1,cl_lines(a5)
	move.w	#0,cl_ploffset(a5)
	clr.w	cl_xmin(a5)
	move.w	#5,cl_ymin(a5)
	move.l	#ClearFind,TRIGGER(a5)
	move.l	TEXT_RPORT(a5),a1
	moveq	#0,d0
	move.l	_GfxBase(a5),a6
	jsr	_LVOSetAPen(a6)
	rts

ClearFind:
	move.l	(a4)+,sp_Event(a5)	; get special clearer event
	move.l	sp_Event(a5),TRIGGER(a5)	; Event *must* set waiter3 and restore a4!
	rts


Clearer:
	; clear 256 lines on 3 planes
	moveq	#0,d0
	moveq	#0,d1
	move.l	TEXT_RPORT(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOMove(a6)

	move.l	TEXT_RPORT(a5),a1
	jsr	_LVOClearScreen(a6)

;	move.l	TEXT_RPORT(a5),a1
;	move.l	rp_BitMap(a1),a1
;	lea	bm_Planes(a1),a1
;	move.l	4(a1),a1
;	move.w	#(40*256)/4-1,d7
;.scud:	clr.l	(a1)+
;	dbra	d7,.scud

	move.w	(a4)+,w3_wait(a5)
	bra	Waiter3




ClearerR31:
	move.w	#60,counter
	move.l	#Cl,TRIGGER(a5)
	rts

Cl:	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0
	move.l	4(a0),a0
	lea	80(a0),a1

	move.w	#(40*58)/4-1,d7

.loop:
	move.l	(a0,d7*4),(a1,d7*4)
;	move.l	#$0f0f0f0f,(a1)+
	dbra	d7,.loop

	sub.w	#1,counter
	beq.b	.goon

	rts

.goon:	move.l	#ClearerR32,TRIGGER(a5)
	rts

counter:	dc.w	0


	; clear upper 60 lines in 3 plane rport
ClearerR32:
	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0


	moveq	#3-1,d6
	moveq	#0,d0

.plloop:	move.l	(a0)+,a2
	move.w	#60-1,d5

.lp:	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+

	dbra	d5,.lp

	dbra	d6,.plloop

	move.w	(a4)+,w3_wait(a5)
;	bra	Waiter3



Waiter3:	move.l	#Waiter3,TRIGGER(a5)

	tst.w	w3_wait(a5)
	bne.b	.fend

	; *** kludge for eoswait=0
	move.l	(a4)+,a4
	move.l	a4,TEXT_PTR(a5)
	beq.b	.w3_end

	move.l	#Initer,TRIGGER(a5)
	bra	Initer


.fend:	subq.w	#1,w3_wait(a5)
	bne.b	.no

	move.l	(a4)+,a4
	move.l	a4,TEXT_PTR(a5)

	beq.b	.w3_end
	move.l	#Initer,TRIGGER(a5)

.no:	rts

.w3_end:	move.l	#Empty,TRIGGER(a5)
	clr.b	TRIG_TEXT(a5)
	rts

Anim1:
	sub.w	#1,ANIM_WAIT(a5)
	bge.b	.goon

	move.l	#Anim11,TRIGGER2(a5)
.goon:	rts

Anim11:
	move.w	a1_ctr(a5),d6
	move.l	ANIM_CURRPTR(a5),a0

	lea	bpl3ptrs,a3
	moveq	#8-1,d7
	move.l	a0,d0
.loop:	move.w	d0,6(a3)
	swap	d0
	move.w	d0,2(a3)
	swap	d0
	addq.w	#8,a3
	add.l	#40*200,d0
	dbra	d7,.loop

	sub.w	#1,a1_ctr(a5)
	bge.b	.goon

	move.w	ANIM_FRAMES(a5),a1_ctr(a5)
	move.l	ANIM_PTR(a5),ANIM_CURRPTR(a5)
	move.l	#Anim1,TRIGGER2(a5)
	move.w	ANIM_FRWAIT(a5),ANIM_WAIT(a5)
	rts

.goon:
	add.l	#40*200*8,ANIM_CURRPTR(a5)
	move.l	#Anim1,TRIGGER2(a5)
	move.w	ANIM_FRWAIT(a5),ANIM_WAIT(a5)
	rts





; ***************************************************************************
; Initialization routines
; ***************************************************************************

Init:
	; *** Get libs
	lea	intname(pc),a1
	moveq	#0,d0
	jsr	_LVOOpenLibrary(a6)

	move.l	d0,_IntuitionBase(a5)
	beq	QuitUgly

	lea	gfxname(pc),a1
	moveq	#39,d0
	jsr	_LVOOpenLibrary(a6)

	move.l	d0,_GfxBase(a5)
	beq	QuitUgly


	; *** Get bitmaps
	move.l	d0,a6

	move.l	#320,d0
	move.l	#256,d1
	moveq	#8,d2
	move.l	#BMF_CLEAR!BMF_DISPLAYABLE,d3
	sub.l	a0,a0
	jsr	_LVOAllocBitMap(a6)
	move.l	d0,bmap(a5)
	beq	QuitUgly

	move.l	#320,d0
	move.l	#256,d1
	moveq	#3,d2
	move.l	#BMF_CLEAR!BMF_DISPLAYABLE,d3
	sub.l	a0,a0
	jsr	_LVOAllocBitMap(a6)
	move.l	d0,bbbmap(a5)
	beq	QuitUgly

	move.l	#320,d0
	move.l	#256,d1
	moveq	#4,d2				; NOTE!!!
	move.l	#BMF_CLEAR!BMF_DISPLAYABLE,d3
	sub.l	a0,a0
	jsr	_LVOAllocBitMap(a6)
	move.l	d0,textbmap(a5)
	beq	QuitUgly

	move.l	#320,d0
	move.l	#256,d1
	moveq	#8,d2
	move.l	#BMF_CLEAR,d3
	sub.l	a0,a0
	jsr	_LVOAllocBitMap(a6)
	move.l	d0,backupbmap(a5)
	beq	QuitUgly

	move.l	#320,d0
	move.l	#256,d1
	moveq	#8,d2
	move.l	#BMF_CLEAR,d3
	sub.l	a0,a0
	jsr	_LVOAllocBitMap(a6)
	move.l	d0,hackbmap(a5)
	beq	QuitUgly

	move.l	#320,d0
	move.l	#256,d1
	moveq	#1,d2
	move.l	#BMF_CLEAR!BMF_DISPLAYABLE,d3
	sub.l	a0,a0
	jsr	_LVOAllocBitMap(a6)
	move.l	d0,bbsbmap(a5)
	beq	QuitUgly


	move.l	#(40*256*8)*9,d0
	move.l	#MEMF_CHIP,d1
	move.l	_ExecBase(a5),a6
	jsr	_LVOAllocMem(a6)

	move.l	d0,animbuffer(a5)
	beq	QuitUgly

	move.l	#(320*256*3),d0
	move.l	#MEMF_PUBLIC,d1
	jsr	_LVOAllocMem(a6)

	move.l	d0,tracebuffer(a5)
	beq	QuitUgly

	move.l	#(170*256*3),d0
	move.l	#MEMF_PUBLIC,d1
	jsr	_LVOAllocMem(a6)

	move.l	d0,tracebuffer2(a5)
	beq	QuitUgly

	move.l	#(320*256)*9,d0
	move.l	#MEMF_PUBLIC,d1
	jsr	_LVOAllocMem(a6)

	move.l	d0,h8chunkybuffer(a5)
	beq	QuitUgly

	bsr	InitFGFont

	; *** Set up fake rastport structures for bms
	lea	bmap(a5),a3
	lea	rport(a5),a4
	move.l	#$cacacaca,d6
	move.l	_GfxBase(a5),a6

	moveq	#6-1,d7
.lpy:	move.l	(a3)+,rp_BitMap(a4)
	move.l	d6,rp_minterms(a4)
	move.l	d6,rp_minterms+4(a4)
	move.b	#-1,rp_Mask(a4)

	move.l	a4,a1
	lea	FGFont,a0
	jsr	_LVOSetFont(a6)

	add.l	#rp_SIZEOF,a4
	dbra	d7,.lpy



	; *** Set up copperlist pointers

;p3:	move.l	bmap(a5),a0
;	lea	bm_Planes(a0),a0
;	lea	Copperlist,a4
;	lea	bplptrs(a4),a4
;	moveq	#2-1,d7
;.loop:	move.l	(a0)+,d0
;	move.w	d0,6(a4)
;	swap	d0
;	move.w	d0,2(a4)
;	addq.w	#8,a4
;	dbra	d7,.loop

	; *** Set up copperlist pointers
	move.l	bmap(a5),a0
	lea	bm_Planes(a0),a0
	lea	bpl3ptrs,a4
	moveq	#8-1,d7
.loop:	move.l	(a0)+,d0
	move.w	d0,6(a4)
	swap	d0
	move.w	d0,2(a4)
	addq.w	#8,a4
	dbra	d7,.loop



	; *** Set up Text hack
	move.l	textbmap(a5),a0
	lea	bm_Planes(a0),a0
	lea	Hookptrs,a4
	lea	NormPtrs,a3
	moveq	#3-1,d7
.loopxx:	move.l	(a0)+,d0
	move.w	d0,6(a4)
	move.w	d0,6(a3)
	swap	d0
	move.w	d0,2(a4)
	move.w	d0,2(a3)
	addq.w	#8,a4
	addq.w	#8,a3
	dbra	d7,.loopxx

	; patch
	move.l	bbsbmap(a5),a0
	lea	bm_Planes(a0),a0
	move.l	(a0),d0
;	move.w	d0,6(a4)
	move.w	d0,6(a3)
	swap	d0
;	move.w	d0,2(a4)
	move.w	d0,2(a3)

nr:
	lea	mod,a0
	move.l	a0,pr_module

	; *** howtocode-style init routines here

	; *** find task pointer and change priority
	sub.l	a1,a1
	move.l	_ExecBase(a5),a6
	jsr	_LVOFindTask(a6)

	move.l	d0,taskptr(a5)

	movea.l	d0,a1
	moveq	#127,d0
	jsr	_LVOSetTaskPri(a6)

	move.b	d0,oldtaskpri+3(a5)

	move.l	_GfxBase(a5),a6
	move.l	gb_ActiView(a6),wbview(a5)

	bsr	FixSpritesSetup         	; fix sprite "bug"...

	move.l	_GfxBase(a5),a6

	sub.l	a1,a1
	jsr	_LVOLoadView(a6)
	jsr	_LVOWaitTOF(a6)
	jsr	_LVOWaitTOF(a6)

	move.l	_ExecBase(a5),a6
	jsr	_LVOForbid(a6)
	move.b	#1,disable_ok(a5)

	lea	_custom,a6
	move.w	intreqr(a6),_intreq(a5)
	move.w	#%0111111111111111,intreq(a6)	; clear all requests

	move.w	intenar(a6),_intena(a5)
	move.w	#%0101111111110000,intena(a6)	; EXTER must be active for CIA replay!


	; *** Get vbr pointer ***

	move.l	a5,-(a7)
	move.l	_ExecBase(a5),a6
	lea	getvbr(pc),a5
	jsr	_LVOSupervisor(a6)
	move.l	(a7)+,a5

	move.l	d0,_SaveVBR(a5)

	move.l	d0,pr_Vectorbasept

	move.l	a5,-(a7)
	bsr	pr_init
	move.l	(a7)+,a5



	; *** set a new cool interrupt.
	; *** we are already disabled.
	move.l	#Empty,TRIGGER(a5)
	move.l	#Empty,TRIGGER2(a5)
	move.l	#Empty,TRIGGERH(a5)

	movea.l	_SaveVBR(a5),a4
	move.l	$6c(a4),_OldVB(a5)
	lea	VBHandler(pc),a0
	move.l	a0,$6c(a4)
	move.b	#1,vb_ok(a5)



	lea	_custom,a6

;	move.l	#Copperlist2,cop1lc(a6)
	move.l	#Copperlist3,cop1lc(a6)
	move.w	#DMAF_SETCLR!DMAF_COPPER!DMAF_RASTER!DMAF_BLITTER,dmacon(a6)

	clr.w	copjmp1(a6)			; strobe - start copper1

	move.w	#INTF_SETCLR!INTF_INTEN!INTF_VERTB,intena(a6)

	rts


; ***********************************************
; getvbr: Launched from Supervisor()
; ***********************************************

getvbr:
	movec	vbr,d0
	rte


; ***********************************************
; FixSpritesSetup
; ***********************************************

FixSpritesSetup:
	move.l	_IntuitionBase(a5),a6
	lea	wbname(pc),a0
	jsr	_LVOLockPubScreen(a6)

	move.l	d0,wbscreen(a5)
	beq.b	.error

	movea.l	d0,a0

	movea.l	sc_ViewPort+vp_ColorMap(a0),a0

	lea	taglist(a5),a1
	move.l	#VTAG_SPRITERESN_GET,(a1)+
	move.l	#SPRITERESN_ECS,(a1)+
	move.l	#TAG_DONE,(a1)

	lea	taglist(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOVideoControl(a6)

	lea	taglist(a5),a1
	move.l	4(a1),oldres(a5)

	lea	taglist(a5),a0
	move.l	#VTAG_SPRITERESN_SET,(a0)+
	move.l	#SPRITERESN_70NS,(a0)

	move.l	wbscreen(a5),a0
	move.l	sc_ViewPort+vp_ColorMap(a0),a0
	lea	taglist(a5),a1
	jsr	_LVOVideoControl(a6)

	move.l	wbscreen(a5),a0
	move.l	_IntuitionBase(a5),a6
	jsr	_LVOMakeScreen(a6)
	jsr	_LVORethinkDisplay(a6)

.error:	rts










	cnop	0,4
HARDBASE:	dc.l	0			; a5 base

	cnop	0,4




; ***************************************************************************
; Data
; ***************************************************************************



	cnop	0,4

controlgr:
	dc.w	0		; 1 = vert center
	dc.w	7		; lines of text
	dc.l	.text01a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.text01b
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.text01c
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.text01d
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.text01e
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.text01f
	dc.b	1,0,2,0
	dc.w	300
	dc.l	Clearer		; Clearer!
	dc.w	100		; EOS wait after clear/special
	dc.l	controlgr2
			   ;123456789012345678901234567890
.text01a:	dc.b	27,"Darkman sends greetings to:"
.text01b:	dc.b	12,"yvind Falch"
.text01c:	dc.b	 9,"Ivan Moen"
.text01d:	dc.b	15,"Perplex/Offence"
.text01e:	dc.b	19,"Mr.Cool/Hellpizzers"
.text01f:	dc.b	13,"and the rest!"
	cnop	0,4


controlgr2:
	dc.w	0		; 1 = vert center
	dc.w	3		; lines of text
	dc.l	.text01a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.text01b
	dc.b	1,0,2,0
	dc.w	150
	dc.l	.text01c
	dc.b	1,0,2,0
	dc.w	300
	dc.l	Clearer		; Clearer!
	dc.w	100		; EOS wait after clear/special
	dc.l	0
			   ;123456789012345678901234567890
.text01a:	dc.b	20,"To iterate is human,"
.text01b:	dc.b	21,"To recurse is divine."
.text01c:	dc.b	28,"No wonder the gods are slow."
	cnop	0,4



control0:
	; init
	; WORD vertcenter, WORD lines
	dc.w	0		; 1 = vert center
	dc.w	1		; lines of text
	dc.l	textskip
	dc.b	1,0,1,0
	dc.w	0
	dc.l	Clearer		; Clearer!
	dc.w	100		; EOS wait after clear/special
	dc.l	control00
;	dc.l	0
	cnop	0,4

control00:
	; init
	; WORD vertcenter, WORD lines
	dc.w	0		; 1 = vert center
	dc.w	3		; lines of text
	dc.l	text01a
	dc.b	1,0,2,0
	dc.w	0
	dc.l	text01b
	dc.b	1,0,2,0
	dc.w	0
	dc.l	text01c
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control02
	dc.l	0
		   ;123456789012345678901234567890
text01a:	dc.b	11,"The masters"
text01b:	dc.b	 2,"of"
text01c:	dc.b	10,"raytracing"
	cnop	0,4

; 4 secs
control02:
	dc.w	0		; 1 = vert center
	dc.w	1		; lines of text
	dc.l	text02a
	dc.b	1,10,2,0
	dc.w	100
	dc.l	Clearer		; Special event ptr
	dc.w	100		; EOS wait after clear/special
	dc.l	control1		; link to next control structure

		   ;123456789012345678901234567890
text02a:	dc.b	 8,"presents"

	cnop	0,4

; 6 secs
control1:
	dc.w	0		; 1 = vert center
	dc.w	4		; lines of text
	dc.l	text1a
	dc.b	1,0,2,0
	dc.w	25
	dc.l	text1b
	dc.b	1,0,2,0
	dc.w	25
	dc.l	text1c
	dc.b	1,0,2,0
	dc.w	25
	dc.l	text1d
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control2

		   ;123456789012345678901234567890
text1a:	dc.b	 1,"A"
text1b:	dc.b	 9,"64k intro"
text1c:	dc.b	11,"released at"
text1d:	dc.b	18,"The Gathering 1995"

	cnop	0,4

control2:
	; init
	dc.w	0		; 1 = vert center
	dc.w	4		; lines of text

	; main
	; BYTE horiz justification (2/1/3), BYTE llwait, BYTE color, BYTE lineendwait
	dc.l	.text2a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,2,0
	dc.w	1
	dc.l	.text2b
	dc.b	1,1,2,0
	dc.w	100
	dc.l	.text2c
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control21
		   ;123456789012345678901234567890
.text2a:	dc.b	12,"Main code by"
.text2b:	dc.b	26,'Nils "Darkman" Corneliusen'
.text2c:	dc.b	26,"(email: nilsco@ifi.uio.no)"
	cnop	0,4

control21:
	; init
	dc.w	0		; 1 = vert center
	dc.w	4		; lines of text
	; main
	; BYTE horiz justification (2/1/3), BYTE llwait, BYTE color, BYTE lineendwait
	dc.l	.text2a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,2,0
	dc.w	1
	dc.l	.text2b
	dc.b	1,1,2,0
	dc.w	100
	dc.l	.text2c
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control22
		   ;123456789012345678901234567890
.text2a:	dc.b	12,"Raytracer by"
.text2b:	dc.b	19,'Per "Quark" degrd'
.text2c:	dc.b	25,"(email: perod@ifi.uio.no)"
	cnop	0,4

control22:
	; init
	dc.w	0		; 1 = vert center
	dc.w	4		; lines of text
	; main
	; BYTE horiz justification (2/1/3), BYTE llwait, BYTE color, BYTE lineendwait
	dc.l	.text2a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,2,0
	dc.w	1
	dc.l	.text2b
	dc.b	1,1,2,0
	dc.w	0
	dc.l	.text2c
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control3
		   ;123456789012345678901234567890
.text2a:	dc.b	10,"Effects by"
.text2b:	dc.b	19,'Carl "Smeagol" Aaby'
.text2c:	dc.b	25,"(email: carla@ifi.uio.no)"




textskip: dc.b	1," "

	cnop	0,4

; 5 secs
control3:
	; init
	dc.w	0		; 1 = vert center
	dc.w	4		; lines of text
	dc.l	.text2a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,2,0
	dc.w	1
	dc.l	.text2b
	dc.b	1,1,2,0
	dc.w	0
	dc.l	.text2c
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control4
		   ;123456789012345678901234567890
.text2a:	dc.b	 8,"Music by"
.text2b:	dc.b	18,'Kent "Flash" Bakke'
.text2c:	dc.b	22,"(email: kbakke@adh.no)"

	cnop	0,4

; 5 secs
control4:
	; init
	dc.w	0		; 1 = vert center
	dc.w	7		; lines of text

	; main
	; BYTE horiz justification (2/1/3), BYTE llwait, BYTE color, BYTE lineendwait
	dc.l	.text4a
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	3,1,2,0
	dc.w	1
	dc.l	.text4b
	dc.b	2,1,2,0
	dc.w	50
	dc.l	.text4c
	dc.b	2,0,2,0
	dc.w	100
	dc.l	textskip
	dc.b	3,1,2,0
	dc.w	1
	dc.l	.text4d
	dc.b	3,0,2,0
	dc.w	50
	dc.l	.text4e
	dc.b	3,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	control5


		   ;123456789012345678901234567890
.text4a:	dc.b	17,"Objects/scenes by"
.text4b:	dc.b	16,'Stig "XTZ" Olsen'
.text4c:	dc.b	25,"(email: stigo@ifi.uio.no)"
.text4d:	dc.b	14,'Morten Johnsen'
.text4e:	dc.b	28,"(email: mortenjo@ifi.uio.no)"


	cnop	0,4

; 12 secs
control5:
	; init
	dc.w	0		; 1 = vert center
	dc.w	2		; lines of text

	; main
	; BYTE horiz justification (2/1/3), BYTE llwait, BYTE color, BYTE lineendwait
	dc.l	text5a
	dc.b	1,0,2,0
	dc.w	100
	dc.l	text5b
	dc.b	1,0,2,0
	dc.w	100
	dc.l	Clearer
	dc.w	100
	dc.l	0

		   ;12345678901234567890123456789012
text5a:	dc.b	20,'We welcome you to...'
text5b:	dc.b	 6,"Speed!"

	cnop	0,4

ControlMove:
	dc.w	0
	dc.w	5
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.textDn2
	dc.b	1,0,2,0
	dc.w	50
	dc.l	.textDn3
	dc.b	1,0,2,0
	dc.w	2
	dc.l	ClearerR31
	dc.w	0
	dc.l	0
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	13,"Triumph says:"
.textDn1:	dc.b	 4,"Move"
.textDn2:	dc.b	 4,"Your"
.textDn3:	dc.b	 4,"Ass!"


	cnop	0,4




ControlDown:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	500
	dc.l	ClearerR31
	dc.w	0
	dc.l	ControlDown2
;	dc.l	0


		   ;123456789012345678901234567890123456789
.textDn0:	dc.b	1," "

	cnop	0,4

ControlDown2:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown3
;	dc.l	0
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	26,"If you can't do it better,"
.textDn1:	dc.b	10,"why do it?"
	cnop	0,4

ControlDown3:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown4
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	16,"Discovered love,"
.textDn1:	dc.b	26,"In the rancid days of ruin"
	cnop	0,4

ControlDown4:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown5
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	25,"My body's sweatin' toxins"
.textDn1:	dc.b	16,"Of my own demise"
	cnop	0,4

ControlDown5:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown6
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	27,"Only from space can you see"
.textDn1:	dc.b	25,"How much earth is burning"
	cnop	0,4

ControlDown6:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	1
	dc.l	0
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	32,"Smokin' out the innocence inside"
.textDn1:	dc.b	 9,"The child"
	cnop	0,4


ControlDown10:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	500
	dc.l	ClearerR31
	dc.w	0
	dc.l	ControlDown12
;	dc.l	0


		   ;123456789012345678901234567890123456789
.textDn0:	dc.b	1," "

	cnop	0,4

ControlDown12:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown13
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	11,"The Juggler"
.textDn1:	dc.b	 9,"Anno 1995"
	cnop	0,4

ControlDown13:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	300
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown14
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	14,"Do you want to"
.textDn1:	dc.b	13,"be hypnotized"
	cnop	0,4

ControlDown14:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown15
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	18,"All you have to do"
.textDn1:	dc.b	17,"is move your body"
	cnop	0,4

ControlDown15:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown16
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	15,"In whatever way"
.textDn1:	dc.b	17,"feels comfortable"
	cnop	0,4

ControlDown16:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown17
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	22,"Just let yourself sink"
.textDn1:	dc.b	15,"into the groove"
	cnop	0,4

ControlDown17:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	0
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	 8,"and move"
	cnop	0,4



ControlDown20:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	500
	dc.l	ClearerR31
	dc.w	0
	dc.l	ControlDown22
;	dc.l	0


		   ;123456789012345678901234567890123456789
.textDn0:	dc.b	1," "

	cnop	0,4

ControlDown22:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown23
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	23,"Well I wish, I was born"
.textDn1:	dc.b	20,"A thousand years ago"
	cnop	0,4

ControlDown23:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown24
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	24,"And I wish that I sailed"
.textDn1:	dc.b	16,"The darkened sea"
	cnop	0,4

ControlDown24:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown25
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	27,"On a great big clipper ship"
.textDn1:	dc.b	30,"Goin' from this land into that"
	cnop	0,4

ControlDown25:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown26
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	25,"In a sailors suit and cap"
	cnop	0,4

ControlDown26:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	0
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	22,"Away from the big city"
.textDn1:	dc.b	22,"Away from the big city"
	cnop	0,4




ControlDown30:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	500
	dc.l	ClearerR31
	dc.w	0
	dc.l	ControlDown32
;	dc.l	0


		   ;123456789012345678901234567890123456789
.textDn0:	dc.b	1," "

	cnop	0,4

ControlDown32:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown33
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	25,"One star flew against the"
.textDn1:	dc.b	16,"tapestry tonight"
	cnop	0,4

ControlDown33:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown34
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	22,"And the earth revolved"
.textDn1:	dc.b	19,"in perfect symmetry"
	cnop	0,4

ControlDown34:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown35
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	20,"To a symphony of sun"
.textDn1:	dc.b	29,"The moon danced its final bow"
	cnop	0,4

ControlDown35:
	dc.w	20
	dc.w	2
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	0
	dc.l	.textDn1
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	ControlDown36
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	19,"As the birth of day"
.textDn1:	dc.b	 8,"Exploded"
	cnop	0,4

ControlDown36:
	dc.w	20
	dc.w	1
	dc.l	.textDn0
	dc.b	1,0,2,0
	dc.w	200
	dc.l	ClearerR31
	dc.w	200
	dc.l	0
			   ;123456789012345678901234567890123456789
.textDn0:	dc.b	10,"In my eyes"
	cnop	0,4





ControlBBS:
	; init
	dc.w	0		; 1 = vert center
	dc.w	5		; lines of text
	dc.l	.textLz0
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz1
	dc.b	1,0,1,0
	dc.w	0
	dc.l	textskip
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz2
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz3
	dc.b	1,0,1,0
	dc.w	600

	dc.l	Clearer
	dc.w	200
	dc.l	ControlBBS11
;	dc.l	0


		   ;123456789012345678901234567890123456789
.textLz0:	dc.b	 4,"Call"
.textLz1:	dc.b	16,"Interference BBS"
.textLz2:	dc.b	32,"Sweden's biggest Amiga PD board!"
.textLz3:	dc.b	29,"Now with 7 nodes online..."
	cnop	0,4

ControlBBS11:
	; init
	dc.w	0		; 1 = vert center
	dc.w	3		; lines of text
	dc.l	.textLz0
	dc.b	1,0,1,0
	dc.w	0
	dc.l	textskip
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz1
	dc.b	1,0,1,0
	dc.w	400

	dc.l	Clearer
	dc.w	200
	dc.l	ControlBBS2


			   ;123456789012345678901234567890123456789
.textLz0:	dc.b	13,"Your Sysop is"
.textLz1:	dc.b	25,'Pierre "Crowley" Andersen'
	cnop	0,4


ControlBBS2:
	; init
	dc.w	0		; 1 = vert center
	dc.w	9		; lines of text
	dc.l	.textLz0
	dc.b	1,0,1,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz1
	dc.b	1,0,1,0
	dc.w	50
	dc.l	.textLz2
	dc.b	1,0,1,0
	dc.w	50
	dc.l	.textLz3
	dc.b	1,0,1,0
	dc.w	50
	dc.l	.textLz4
	dc.b	1,0,1,0
	dc.w	50
	dc.l	.textLz5
	dc.b	1,0,1,0
	dc.w	50
	dc.l	.textLz6
	dc.b	1,0,1,0
	dc.w	50
	dc.l	.textLz7
	dc.b	1,0,1,0
	dc.w	500

	dc.l	Clearer
	dc.w	200
	dc.l	ControlBBS3


			   ;123456789012345678901234567890123456789
.textLz0:	dc.b	13,"Dial +46-525-"
.textLz1:	dc.b	20,"13136 (V.Fast 28800)"
.textLz2:	dc.b	20,"13091 (USR DS 14400)"
.textLz3:	dc.b	20,"13092 (USR DS 16800)"
.textLz4:	dc.b	20,"13094 (V.Fast 28800)"
.textLz5:	dc.b	20,"13095 (V.Fast 28800)"
.textLz6:	dc.b	21,"13098 (USR V34 28800)"
.textLz7:	dc.b	21,"13137 (USR V34 28800)"
	cnop	0,4


ControlBBS3:
	; init
	dc.w	0		; 1 = vert center
	dc.w	9		; lines of text
	dc.l	.textLz0
	dc.b	1,0,1,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz1
	dc.b	2,0,1,0
	dc.w	50
	dc.l	.textLz2
	dc.b	2,0,1,0
	dc.w	50
	dc.l	.textLz3
	dc.b	2,0,1,0
	dc.w	50
	dc.l	.textLz4
	dc.b	2,0,1,0
	dc.w	50
	dc.l	.textLz5
	dc.b	2,0,1,0
	dc.w	50
	dc.l	textskip
	dc.b	1,0,1,0
	dc.w	0
	dc.l	.textLz6
	dc.b	1,0,1,0
	dc.w	400

	dc.l	Clearer
	dc.w	200
	dc.l	0


			   ;123456789012345678901234567890123456789
.textLz0:	dc.b	 9,"Features:"
.textLz1:	dc.b	19,"- running on A3000T"
.textLz2:	dc.b	23,"- 2Gb online, 6Gb space"
.textLz3:	dc.b	16,"- NEC CD changer"
.textLz4:	dc.b	10,"- 18Mb ram"
.textLz5:	dc.b	15,"- 100 file dirs"
.textLz6:	dc.b	25,"using ABBS as BBS system!"
	cnop	0,4



; ***************************************************************************
; END ROUTINES!
; ***************************************************************************

QuitUgly:
	move.l	#$8555DEAD,d7
	move.l	$4.w,a6
	jsr	_LVOAlert(a6)


.coke:	move.w	#$0f00,$dff180
	btst.b	#6,$bfe001
	bne.b	.coke

QuitNice:

	tst.b	vb_ok(a5)
	beq.b	no_vb

	move.l	a5,-(a7)
	bsr	pr_end
	move.l	(a7)+,a5


	lea	_custom,a6

	move.w	#INTF_VERTB,intena(a6)		; disable vb interrupt

	move.w	_intreq(a5),d0
	or.w	#INTF_SETCLR,d0
	move.w	d0,intreq(a6)			; restore old pending interrupts

	move.w	_intena(a5),d0
	or.w	#INTF_SETCLR,d0
	move.w	d0,intena(a6)			; restore old int bits

	move.l	_SaveVBR(a5),a4
	move.l	_OldVB(a5),$6c(a4)


no_vb:
	tst.l	wbscreen(a5)
	beq.b	ep

	bsr	ReturnSpritesToNormal

	tst.b	disable_ok(a5)
	beq.b	no_dis

	move.l	_ExecBase(a5),a6
	jsr	_LVOPermit(a6)

no_dis:	move.l	wbview(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOLoadView(a6)
	jsr	_LVOWaitTOF(a6)
	jsr	_LVOWaitTOF(a6)

	move.l	gb_copinit(a6),_custom+cop1lc

	move.l	_IntuitionBase(a5),a6
	jsr	_LVORethinkDisplay(a6)

ep:	move.l	taskptr(a5),a1
	move.l	oldtaskpri(a5),d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOSetTaskPri(a6)


ey:	move.l	_IntuitionBase(a5),d0
	beq.b	e3
	movea.l	d0,a1
	jsr	_LVOCloseLibrary(a6)

	; *** Free all bitmaps
e3:	lea	bmap(a5),a4		; OOPS
	move.l	_GfxBase(a5),a6
	moveq	#6-1,d7

.lp:	move.l	(a4)+,d0
	beq.b	e31
	move.l	d0,a0
	jsr	_LVOFreeBitMap(a6)
	dbra	d7,.lp


e31:	lea	FGFont,a0
	move.l	_GfxBase(a5),a6
	jsr	_LVOStripFont(a6)

	move.l	_GfxBase(a5),d0
	beq.b	e4
	move.l	d0,a1
	move.l	_ExecBase(a5),a6
	jsr	_LVOCloseLibrary(a6)



e4:	move.l	tracebuffer(a5),d0
	beq.b	e41
	movea.l	d0,a1
	move.l	#(320*256*3),d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

e41:	move.l	tracebuffer2(a5),d0
	beq.b	e5
	movea.l	d0,a1
	move.l	#(170*256*3),d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

e5:	move.l	animbuffer(a5),d0
	beq.b	e6
	movea.l	d0,a1
	move.l	#(40*256*8)*9,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

e6:	move.l	h8chunkybuffer(a5),d0
	beq.b	nomorebufstofree
	movea.l	d0,a1
	move.l	#(320*256)*9,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)



nomorebufstofree:

	move.l	_SaveSP(a5),-(a7)

	move.l	a5,a1
	move.l	#gldata_SIZEOF,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

	move.l	(a7)+,d0

	move.l	d0,a7

	movem.l	(a7)+,d0-d7/a0-a6
	moveq	#0,d0
	rts


; ***********************************************
; ReturnSpritesToNormal
; ***********************************************

ReturnSpritesToNormal:
	move.l	wbscreen(a5),a0

	lea	taglist(a5),a1
	move.l	#VTAG_SPRITERESN_SET,(a1)+
	move.l	oldres(a5),(a1)+
	move.l	#TAG_DONE,(a1)

	lea	taglist(a5),a1
	move.l	sc_ViewPort+vp_ColorMap(a0),a0
	move.l	_GfxBase(a5),a6
	jsr	_LVOVideoControl(a6)		; return sprites to normal.

	move.l	wbscreen(a5),a0
	move.l	_IntuitionBase(a5),a6
	jsr	_LVOMakeScreen(a6)		; and rebuild screen

	move.l	wbscreen(a5),a1
	sub.l	a0,a0
	jsr	_LVOUnlockPubScreen(a6)

.error
        rts





wbname:		dc.b	"Workbench",0
gfxname:		dc.b	"graphics.library",0
intname:		dc.b	"intuition.library",0

	cnop	0,8

_DestPtr:	dc.l	0
_ScenePtr:	dc.l	0

regz:	dcb.l	20,0
regz2:	dcb.l	20,0



	SECTION	stuff2,data

	cnop	0,8

blankscene:	incbin	"scenes/allblank.presc"

redc_animtbl:
	dc.l	redc1_anim
	dc.l	redc2_anim
	dc.l	redc3_anim
	dc.l	redc4_anim
	dc.l	redc5_anim
	dc.l	redc6_anim
	dc.l	redc7_anim
	dc.l	redc8_anim

;redc_animtbl:
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene



redc1_anim:	incbin	"scenes/redc/redc001.presc"
redc2_anim:	incbin	"scenes/redc/redc002.presc"
redc3_anim:	incbin	"scenes/redc/redc003.presc"
redc4_anim:	incbin	"scenes/redc/redc004.presc"
redc5_anim:	incbin	"scenes/redc/redc005.presc"
redc6_anim:	incbin	"scenes/redc/redc006.presc"
redc7_anim:	incbin	"scenes/redc/redc007.presc"
redc8_anim:	incbin	"scenes/redc/redc008.presc"



blue_animtbl:
	dc.l	blue1_anim
	dc.l	blue3_anim
	dc.l	blue5_anim
	dc.l	blue7_anim

;blue_animtbl:
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene



blue1_anim:	incbin	"scenes/blue/blue001.presc"
blue3_anim:	incbin	"scenes/blue/blue003.presc"
blue5_anim:	incbin	"scenes/blue/blue005.presc"
blue7_anim:	incbin	"scenes/blue/blue007.presc"


juggler_animtbl:
	dc.l	juggler1_anim
	dc.l	juggler2_anim
	dc.l	juggler3_anim
	dc.l	juggler4_anim

;juggler_animtbl:
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene


juggler1_anim:	incbin	"scenes/juggler3/juggler1.presc"
juggler2_anim:	incbin	"scenes/juggler3/juggler2.presc"
juggler3_anim:	incbin	"scenes/juggler3/juggler3.presc"
juggler4_anim:	incbin	"scenes/juggler3/juggler4.presc"


col8_animtbl:
	dc.l	color81_anim
	dc.l	color82_anim
	dc.l	color83_anim
	dc.l	color84_anim
	dc.l	color85_anim
	dc.l	color86_anim
	dc.l	color87_anim
	dc.l	color88_anim

;col8_animtbl:
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene
;	dc.l	blankscene



color81_anim:	incbin	"scenes/color8/col001.presc"
color82_anim:	incbin	"scenes/color8/col002.presc"
color83_anim:	incbin	"scenes/color8/col003.presc"
color84_anim:	incbin	"scenes/color8/col004.presc"
color85_anim:	incbin	"scenes/color8/col005.presc"
color86_anim:	incbin	"scenes/color8/col006.presc"
color87_anim:	incbin	"scenes/color8/col007.presc"
color88_anim:	incbin	"scenes/color8/col008.presc"





still3_pic:
;		incbin	"scenes/stigo/still3.presc"
		incbin	"scenes/new/logo3.presc"
;		incbin	"scenes/blank.presc"
;		incbin	"scenes/triumph.presc"
;		incbin	"scenes/tri.presc"


SinusTable:	incbin	"hey/sincostable"
CosinusTable=SinusTable+512


	SECTION	hey,data_c

	cnop	0,8



NormCopper:
	dc.w	$01fc,%0000000000000000		; don't need aga here...

	dc.l	$200ffffe

NormPtrs:
	dc.l	$00e00000
	dc.l	$00e20000
	dc.l	$00e40000
	dc.l	$00e60000
	dc.l	$00e80000
	dc.l	$00ea0000
	dc.l	$00ec0000
	dc.l	$00ee0000
	dc.w	dmacon,%0000010000100000

		;        H421HDCGXXX8LIEX
	dc.w	bplcon0,%0100000000000000	; set 3+3 planes
	dc.w	bpl1mod,0
	dc.w	bpl2mod,0
	dc.w	diwstrt,$2c81
	dc.w	diwstop,$2cc1
	dc.w	ddfstrt,$0038
	dc.w	ddfstop,$00d0
	dc.w	bplcon1,$0000
	dc.w	bplcon2,$0000
	dc.w	$0106,%0000000000000000

NormCol:	dc.l	$01800000
	dc.l	$01820fff
ncmsb:	dc.l	$01840fff
	dc.l	$01860fff
	dc.l	$01880fff
	dc.l	$018a0fff
	dc.l	$018c0fff
	dc.l	$018e0fff


	dc.w	$0106,%0000001000000000		; palette 0, lsb
lsb:	dc.l	$01800000

; end here
	WA	$df,$ff
	WA	$09,$2c

	dc.w	bplcon0,%1000001000000000

	WA	$FF,$ff			;end...
	WA	$FF,$ff

	dc.l	-1


	cnop	0,8




; HAM 8 copperlist 4x4x4 with patch at end
	cnop	0,8
Copperlist3:
	dc.w	dmacon,%0000010000100000

	dc.l	$1d01fffe


		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0000000000000000		; palette 0, msb
	dc.l	$01800000,$01820004,$01840008,$0186000c
	dc.l	$01880040,$018a0044,$018c0048,$018e004c
	dc.l	$01900080,$01920084,$01940088,$0196008c
	dc.l	$019800c0,$019a00c4,$019c00c8,$019e00cc
	dc.l	$01a00400,$01a20404,$01a40408,$01a6040c
	dc.l	$01a80440,$01aa0444,$01ac0448,$01ae044c
	dc.l	$01b00480,$01b20484,$01b40488,$01b6048c
	dc.l	$01b804c0,$01ba04c4,$01bc04c8,$01be04cc

		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0000001000000000		; palette 0, lsb
	dc.l	$01800000,$01820000,$01840000,$01860000
	dc.l	$01880000,$018a0000,$018c0000,$018e0000
	dc.l	$01900000,$01920000,$01940000,$01960000
	dc.l	$01980000,$019a0000,$019c0000,$019e0000
	dc.l	$01a00000,$01a20000,$01a40000,$01a60000
	dc.l	$01a80000,$01aa0000,$01ac0000,$01ae0000
	dc.l	$01b00000,$01b20000,$01b40000,$01b60000
	dc.l	$01b80000,$01ba0000,$01bc0000,$01be0000

		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0010000000000000		; palette 1, msb
	dc.l	$01800800,$01820804,$01840808,$0186080c
	dc.l	$01880840,$018a0844,$018c0848,$018e084c
	dc.l	$01900880,$01920884,$01940888,$0196088c
	dc.l	$019808c0,$019a08c4,$019c08c8,$019e08cc
	dc.l	$01a00c00,$01a20c04,$01a40c08,$01a60c0c
	dc.l	$01a80c40,$01aa0c44,$01ac0c48,$01ae0c4c
	dc.l	$01b00c80,$01b20c84,$01b40c88,$01b60c8c
	dc.l	$01b80cc0,$01ba0cc4,$01bc0cc8,$01be0ccc

		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0010001000000000		; palette 1, lsb
	dc.l	$01800000,$01820000,$01840000,$01860000
	dc.l	$01880000,$018a0000,$018c0000,$018e0000
	dc.l	$01900000,$01920000,$01940000,$01960000
	dc.l	$01980000,$019a0000,$019c0000,$019e0000
	dc.l	$01a00000,$01a20000,$01a40000,$01a60000
	dc.l	$01a80000,$01aa0000,$01ac0000,$01ae0000
	dc.l	$01b00000,$01b20000,$01b40000,$01b60000
	dc.l	$01b80000,$01ba0000,$01bc0000,$01be0000


	dc.w	bplcon4,$0000
	dc.w	diwstrt,$2781

		;        H421M C    8   E
	dc.w	bplcon0,%0000101000010001

		;            E
		;      5432109876543210
	dc.w	bplcon2,%0000001000000000

		;      210       B
		;      5432109876543210
	dc.w	bplcon3,%0000110000100000

	dc.w	diwstop,$27c1
	dc.w	ddfstrt,$0038
	dc.w	ddfstop,$00D8

	dc.w	bplcon1,%0000000000000000


	dc.w	bpl1mod,-8
	dc.w	bpl2mod,-8

bpl3ptrs:
	dc.w	$00e0,$0000
	dc.w	$00e2,$0000
	dc.w	$00e4,$0000
	dc.w	$00e6,$0000
	dc.w	$00e8,$0000
	dc.w	$00ea,$0000
	dc.w	$00ec,$0000
	dc.w	$00ee,$0000
	dc.w	$00f0,$0000
	dc.w	$00f2,$0000
	dc.w	$00f4,$0000
	dc.w	$00f6,$0000
	dc.w	$00f8,$0000
	dc.w	$00fa,$0000
	dc.w	$00fc,$0000
	dc.w	$00fe,$0000

	dc.w	diwhigh,$2100
	dc.w	fmode,$0003

	; patch for other bitmap
	dc.l	$ef0ffffe
;	dc.l	$01800f00

Hookptrs:
	dc.l	$00e00000
	dc.l	$00e20000
	dc.l	$00e40000
	dc.l	$00e60000
	dc.l	$00e80000
	dc.l	$00ea0000
	dc.w	dmacon,%0000010000100000
	dc.w	bplcon0,%0011000000000000	; set 3 planes
	dc.w	bpl1mod,0
	dc.w	bpl2mod,0
	dc.w	diwstrt,$2c81
	dc.w	diwstop,$2cc1
	dc.w	ddfstrt,$0038
	dc.w	ddfstop,$00d0
	dc.w	bplcon1,$0000
	dc.w	bplcon2,$0000
	dc.w	$0106,%0000000000000000
col2:	dc.l	$01800000
	dc.l	$01820b08
	dc.l	$01840b08
	dc.l	$01860111
	dc.l	$01880E84
	dc.l	$018a0FA4
	dc.l	$018c0CBA
	dc.l	$018e0933

	dc.w	$01fc,%0000000000000000		; don't need aga here...
;	dc.l	$0180000f
	WA	$FF,$ff			;end...
	WA	$FF,$ff

	dc.l	-1


; HAM 8 copperlist 4x4x4 without patch at end

	cnop	0,8
CopperlistH8:
	dc.w	dmacon,%0000010000100000

	dc.l	$1d01fffe


		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0000000000000000		; palette 0, msb
	dc.l	$01800000,$01820004,$01840008,$0186000c
	dc.l	$01880040,$018a0044,$018c0048,$018e004c
	dc.l	$01900080,$01920084,$01940088,$0196008c
	dc.l	$019800c0,$019a00c4,$019c00c8,$019e00cc
	dc.l	$01a00400,$01a20404,$01a40408,$01a6040c
	dc.l	$01a80440,$01aa0444,$01ac0448,$01ae044c
	dc.l	$01b00480,$01b20484,$01b40488,$01b6048c
	dc.l	$01b804c0,$01ba04c4,$01bc04c8,$01be04cc

		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0000001000000000		; palette 0, lsb
	dc.l	$01800000,$01820000,$01840000,$01860000
	dc.l	$01880000,$018a0000,$018c0000,$018e0000
	dc.l	$01900000,$01920000,$01940000,$01960000
	dc.l	$01980000,$019a0000,$019c0000,$019e0000
	dc.l	$01a00000,$01a20000,$01a40000,$01a60000
	dc.l	$01a80000,$01aa0000,$01ac0000,$01ae0000
	dc.l	$01b00000,$01b20000,$01b40000,$01b60000
	dc.l	$01b80000,$01ba0000,$01bc0000,$01be0000

		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0010000000000000		; palette 1, msb
	dc.l	$01800800,$01820804,$01840808,$0186080c
	dc.l	$01880840,$018a0844,$018c0848,$018e084c
	dc.l	$01900880,$01920884,$01940888,$0196088c
	dc.l	$019808c0,$019a08c4,$019c08c8,$019e08cc
	dc.l	$01a00c00,$01a20c04,$01a40c08,$01a60c0c
	dc.l	$01a80c40,$01aa0c44,$01ac0c48,$01ae0c4c
	dc.l	$01b00c80,$01b20c84,$01b40c88,$01b60c8c
	dc.l	$01b80cc0,$01ba0cc4,$01bc0cc8,$01be0ccc

		;      BBBxxxLxxxxxxxxx
	dc.w	$0106,%0010001000000000		; palette 1, lsb
	dc.l	$01800000,$01820000,$01840000,$01860000
	dc.l	$01880000,$018a0000,$018c0000,$018e0000
	dc.l	$01900000,$01920000,$01940000,$01960000
	dc.l	$01980000,$019a0000,$019c0000,$019e0000
	dc.l	$01a00000,$01a20000,$01a40000,$01a60000
	dc.l	$01a80000,$01aa0000,$01ac0000,$01ae0000
	dc.l	$01b00000,$01b20000,$01b40000,$01b60000
	dc.l	$01b80000,$01ba0000,$01bc0000,$01be0000


	dc.w	bplcon4,$0000
	dc.w	diwstrt,$2781

		;        H421M C    8   E
	dc.w	bplcon0,%0000101000010001

		;            E
		;      5432109876543210
	dc.w	bplcon2,%0000001000000000

		;      210       B
		;      5432109876543210
	dc.w	bplcon3,%0000110000100000

	dc.w	diwstop,$27c1
	dc.w	ddfstrt,$0038
	dc.w	ddfstop,$00D8

	dc.w	bplcon1,%0000000000000000


	dc.w	bpl1mod,-8
	dc.w	bpl2mod,-8

bplH8ptrs:
	dc.w	$00e0,$0000
	dc.w	$00e2,$0000
	dc.w	$00e4,$0000
	dc.w	$00e6,$0000
	dc.w	$00e8,$0000
	dc.w	$00ea,$0000
	dc.w	$00ec,$0000
	dc.w	$00ee,$0000
	dc.w	$00f0,$0000
	dc.w	$00f2,$0000
	dc.w	$00f4,$0000
	dc.w	$00f6,$0000
	dc.w	$00f8,$0000
	dc.w	$00fa,$0000
	dc.w	$00fc,$0000
	dc.w	$00fe,$0000

	dc.w	diwhigh,$2100
	dc.w	fmode,$0003

	WA	$FF,$ff			;end...
	WA	$FF,$ff

	dc.l	-1

	cnop	0,8
;---------------------------
;- Copperlist - Copperlist -
;---------------------------
copper:
	dc.w	$01fc,%0000000000000000		; don't need aga here...
	dc.w	$0106,$0

	dc.w	$0102,$0000
	dc.w	$0104,$0000
	dc.w	$0108,$0000
	dc.w	$010a,$0000
	dc.w	$008e,$2c81
	dc.w	$0090,$f4c1
	dc.w	$0090,$38c1
	dc.w	$0092,$0038
	dc.w	$0094,$00d0

	dc.w	$0106,$0000
copmsb:	dc.w	$0180,$0000
	dc.w	$0106,%0000001000000000		; palette 0, lsb
coplsb:	dc.w	$0180,$0000

	dc.w	$0106,$0000

	dc.w	$0190,$0fff,$0192,$0fff,$0194,$0fff,$0196,$0fff
	dc.w	$0198,$0fff,$019a,$0fff,$019c,$0fff,$019e,$0fff

	dc.w	$2c01,$fffe
	dc.w	$0100,$4200
textbplcop:
	dc.w	$00ec,$0000
	dc.w	$00ee,$0000
bplcop:
	dc.w	$00e0,$0000
	dc.w	$00e2,$0000
	dc.w	$00e4,$0000
	dc.w	$00e6,$0000
	dc.w	$00e8,$0000
	dc.w	$00ea,$0000

firstrow:
	dcb.w	(14*3*63),0

	dc.w	$6c01,$fffe
bplcop2:
	dc.w	$00e0,$0000
	dc.w	$00e2,$0000
	dc.w	$00e4,$0000
	dc.w	$00e6,$0000
	dc.w	$00e8,$0000
	dc.w	$00ea,$0000

secondrow:
	dcb.w	(14*2*63),0

	dc.w	$ac01,$fffe
bplcop3:
	dc.w	$00e0,$0000
	dc.w	$00e2,$0000
	dc.w	$00e4,$0000
	dc.w	$00e6,$0000
	dc.w	$00e8,$0000
	dc.w	$00ea,$0000

thirdrow:
	dcb.w	(14*3*63),0
	
	dc.w	$ec01,$fffe
bplcop4:
	dc.w	$00e0,$0000
	dc.w	$00e2,$0000
	dc.w	$00e4,$0000
	dc.w	$00e6,$0000
	dc.w	$00e8,$0000
	dc.w	$00ea,$0000

row4:
	dcb.w	(14*2*19),0
	dc.l	0
	dcb.w	(14*2*44),0
	
	dc.w	$2c01,$fffe
	dc.w	$0100,$0200
	dc.w	$ffff,$fffe
	dc.w	$ffff,$fffe

	cnop	0,8
;-------------------------------
;- Buffers - Buffers - Buffers -
;-------------------------------
cubebuffer:	dcb.b	2560*3,0
cubebuffer2:	dcb.b	2560*3,0
screen:		dcb.b	2560*3,0
screen2:		dcb.b	2560*3,0


	cnop	0,8

mod:
;	incbin	"music/mod.interference.pro"
	incbin	"music/mod.speed_final.pro"
;	incbin	"music/mod.dos_theme_2.pro"

	cnop	0,8
movey:	incbin	"move_your_ass.raw"


	cnop	0,8
Background:	incbin	"background.raw"	; 320x256x1

Silence:	dc.w	0

