#include	<stdio.h>
#include <stdlib.h>
#include <string.h>
#include	<exec/exec.h>
#include	<dos/dos.h>
#include <clib/dos_protos.h>
#include <clib/exec_protos.h>
#include <math.h>
#include <m68881.h>



void cleanup( char *err );
APTR AllocAndLoad( char *, int * );

// Globals
APTR ufileptr = NULL;
int ufilelen;

double *pts = NULL;
int points;

BPTR ofile = NULL;

int sfactor = 0;
// heh

int zep = 0;

int main( int argc, char *argv[] )
{
	int tst;
	int tst1;
	double tst2;

	char inbuf[80];
	char outbuf[80];
	char outbuf1[120];
	char outbuf2[120];
	char outbuf3[120];
	int i;
	int temp1;
	int tmp;

	char *fptr;

	printf( "%x\n%x\n%x\n", &tst, &tst1, &tst2 );

	puts( "Lw2Dat by Nils Corneliusen of Triumph Software" );
	puts( "----------------------------------------------" );
	puts( "A quick hack to convert videoscape v1 objects to" );
	puts( "the dat format used in trace." );

	if( argc < 4 ) {
		puts( "Usage: lw2dat <infile> <outfile> <factor>" );
		puts( "<infile>:  input filename" );
		puts( "<outfile>: output filename" );
		puts( "<factor>:  Data scale factor" );
		cleanup( "hh skjnner du eller?" );
	}

	sfactor = atoi( argv[3] );

	if( ufileptr = AllocAndLoad( argv[1], &ufilelen ) ) {

		fptr = (char *) ufileptr;

		for( zep = 0; (inbuf[zep] = *fptr++) != 10; zep++ )
			;
		inbuf[zep] = '\0';

		if( strcmp( inbuf, "3DG1" ) )
			cleanup( "Error: File not in 3DG1 format!" );

		for( zep = 0; (inbuf[zep] = *fptr++) != 10; zep++ )
			;
		inbuf[zep] = '\0';
		points = atoi( inbuf );
		printf( "Points: %d\n", points );

		if( !(pts = (double *) AllocMem( points * 3 * sizeof(double), MEMF_ANY )) )
			cleanup( "Couldn't get points buffer!" );

		for( i = 0; i < points; i++ ) {

			for( zep = 0; (inbuf[zep] = *fptr++) != 32; zep++ )
				;
			inbuf[zep] = '\0';
			pts[i*3] = atof( inbuf );
			for( zep = 0; (inbuf[zep] = *fptr++) != 32; zep++ )
				;
			inbuf[zep] = '\0';
			pts[i*3+1] = atof( inbuf );
			for( zep = 0; (inbuf[zep] = *fptr++) != 10; zep++ )
				;
			inbuf[zep] = '\0';
			pts[i*3+2] = atof( inbuf );

		}
		puts( "Structure built..." );

		if( !(ofile = Open( argv[2], MODE_NEWFILE )) )
			cleanup( "Error creating outfile!" );

		while( fptr < ((char *)ufileptr)+ufilelen ) {

			for( zep = 0; (inbuf[zep] = *fptr++) != 32; zep++ )
				;
			inbuf[zep] = '\0';
			tmp = atoi( inbuf );
			if( tmp != 3 )
				cleanup( "Hey! Stick to triangles!" );

			// coord 1
			for( zep = 0; (inbuf[zep] = *fptr++) != 32; zep++ )
				;
			inbuf[zep] = '\0';
			temp1 = atoi( inbuf );

			// temp1 = offset
			sprintf( outbuf1, "%f, %f, %f, ",
				pts[temp1*3]*sfactor, pts[temp1*3+1]*sfactor, pts[temp1*3]*sfactor );


			// coord 2
			for( zep = 0; (inbuf[zep] = *fptr++) != 32; zep++ )
				;
			inbuf[zep] = '\0';
			temp1 = atoi( inbuf );

			// temp1 = offset
			sprintf( outbuf2, "%f, %f, %f, ",
				pts[temp1*3]*sfactor, pts[temp1*3+1]*sfactor, pts[temp1*3]*sfactor );


			// coord 3
			for( zep = 0; (inbuf[zep] = *fptr++) != 32; zep++ )
				;
			inbuf[zep] = '\0';
			temp1 = atoi( inbuf );

			// temp1 = offset
			sprintf( outbuf3, "%f, %f, %f,\n",
				pts[temp1*3]*sfactor, pts[temp1*3+1]*sfactor, pts[temp1*3]*sfactor );



			for( zep = 0; (inbuf[zep] = *fptr++) != 10; zep++ )
				;
			inbuf[zep] = '\0';
			temp1 = atoi( inbuf );

			sprintf( outbuf, "#triangle\nmat%d, 0, 0, 0, ", temp1 );
			Write( ofile, outbuf, strlen( outbuf ) );
			Write( ofile, outbuf1, strlen( outbuf1 ) );
			Write( ofile, outbuf2, strlen( outbuf2 ) );
			Write( ofile, outbuf3, strlen( outbuf3 ) );



		}

	}

	cleanup( NULL );
}

void cleanup( char *err )
{
	if( ufileptr ) FreeMem( ufileptr, ufilelen );
	if( pts ) FreeMem( pts, points * 3 );
	if( ofile ) Close( ofile );
	if( err ) puts ( err );
	exit( 0 );
}


APTR AllocAndLoad( char *fname, int *size )
{
	APTR loc = 0;
	BPTR fileptr;
	BPTR filelock;
	LONG fileread;
	struct FileInfoBlock *fib;
	int aerror = 0;

	if( filelock = Lock( fname, ACCESS_READ ) ) {

		if( fib = (struct FileInfoBlock *) AllocDosObject( DOS_FIB, NULL ) ) {

			if( Examine( filelock, fib ) ) {

				if( fib->fib_DirEntryType < 0 ) {

					if( fileptr = Open( fname, MODE_OLDFILE ) ) {

						if( loc = AllocMem( fib->fib_Size, MEMF_ANY ) ) {

							fileread = Read( fileptr, loc, fib->fib_Size );

							if( fileread != fib->fib_Size )
								puts( "Warning: File truncated!" );

							aerror = 1;

						}

						Close( fileptr );
					}

				}

			}

			FreeDosObject( DOS_FIB, (void *) fib );
		}

		UnLock( filelock );
	}

	if( !aerror ) {
		PrintFault( IoErr(), fname );
		*size = 0;
	} else
		*size = fib->fib_Size;

	return (APTR) loc;
}
