// Copyright (c) 1994 by Per Christian Oedegaard.  All Rights Reserved
/***
  NAME
  trace

  PURPOSE
  A generic tracer :)
     
  NOTES
  Sorry, the author is an imposter, not a composer :-)
     
  HISTORY
  perod - Apr 4, 1994: Created.

  nilsco - changes 940116:
  nilsco - changes 950130:
  nilsco - changes 950219:


Test run of redc001.dat

SPROF: Please run the program to be profiled now.
SPROF: Waiting for process...
SPROF: Contacted process 0x07a155c0

SPROF Report
Status: Complete
Name                                         Count  ITime  ETime Pct
\TRACE.CC\trace__FPc\7411                        1 103251  58892  56.7
\TRACE.CC\intersect__6sphereFddddddRd\6386 1326899  42218  42218  40.7
\TRACE.CC\getns__6sphereFddd\6239            55733   2141   2141   2.1
\TRACE.CC\dotrace__FiPdPcPc\8515                 1 103675    423   0.4
\TRACE.CC\readfile__FPcPi\7716                   1     98     98   0.1
\TRACE.CC\preparse__FPcPc\8343                   1     28     28   0.0
\TRACE.CC\set__6sphereFPcP8material\6200         8      1      1   0.0
\TRACE.CC\massacre__Fv\6974                      1      0      0   0.0
\TRACE.CC\init_struct__FPc\6887                  1      1      0   0.0
\iostream.h\_STD_5000_TRACE\8723                 1      0      0   0.0
                                                          ------ -----
                                                          103801 100.0


***/

/*
sc link math 68882 cpu 68040 opt optrdep=30 optinl optloop opttime optsched optcomp=30 gst all.gst define AMIGA=1 define STANDALONE=1 cxxsrc trace.cc
sc link math 68882 cpu 68040 gst all.gst cxxsrc trace.cc
*/

// #define AMIGA 1
// #define INTRO 1
// #define STANDALONE 1
// #define PC 1


// INCLUDES:

#include <stdio.h>
#ifdef STANDALONE
#include <stdlib.h>

#include <iostream.h>
#include <fstream.h>

#include <string.h>

// I *hate* SAS/C include bugs... sigh.
#ifdef AMIGA
#undef __cplusplus
#endif

#include <fcntl.h>      // C

#endif

#include <math.h>

#ifdef AMIGA
#include <m68881.h>
#endif


#ifdef INTRO
__far __asm extern void asmHitMe( void );        // from start.s
__far __asm extern void entf1( void );            // from start.s
__far __asm extern void ents1( void );            // from start.s
__far extern char *DestPtr;
__far extern char *ScenePtr;
#endif

#define TRUE  1
#define FALSE 0



#define SCENE    999
#define LIGHT    1000
#define TRIANGLE 1001
#define SPHERE   1002
#define MATERIAL 1003
#define UNDEF    1004

// enum command {SCENE, LIGHT, TRIANGLE, SPHERE, MATERIAL, UNDEF};

#define command int

#ifdef STANDALONE

typedef struct mats {
	struct mats *nmat;
	char matname[76];
	int mid;
};

struct mats *matlist;

struct mats *findmat( char * );

#endif

#define dot(x1,y1,z1,x2,y2,z2) (x1*x2 + y1*y2 + z1*z2)

enum hitmode {DIFFUSE, REFLECT, BACKGROUND};

char *reader;
char *mreader;
double *parsebuf = 0;
char *prescene;


char *fptr;
int zep;


char *pict;

int debug;

// Normalizes the triple (a,b,c)

__inline void normalize(double& a, double& b, double& c)
{
  double len;
  len = sqrt(a*a + b*b + c*c);
  a = a/len; b = b/len; c = c/len;
}




//
// ******** STRUCTURES AND CLASSES ********
//


struct bounding_box                         // Bounding box structure
{
  double min_x, max_x, min_y, max_y, min_z, max_z;
};


struct a_scene
{
	double bgcol_r, bgcol_g, bgcol_b;         // Background color
	double ambli_r, ambli_g, ambli_b;         // Ambient light intensity
	double eye_rng;
	double src_x, src_y, src_z;
	double dest_x, dest_y, dest_z;
	double bank, zoom;
	int max_iter;                             // Max # of beam-iterations
	int max_depth;                            // Max depth of ray-tree
	int width, height, aaval;                 // Picture size
	bounding_box bbox;

	void set( char *src )
	{
		bgcol_r = *((double *)src); src+=8;
		bgcol_g = *((double *)src); src+=8;
		bgcol_b = *((double *)src); src+=8;
		ambli_r = *((double *)src); src+=8;
		ambli_g = *((double *)src); src+=8;
		ambli_b = *((double *)src); src+=8;
		eye_rng = *((double *)src); src+=8;
		src_x = *((double *)src); src+=8;
		src_y = *((double *)src); src+=8;
		src_z = *((double *)src); src+=8;
		dest_x = *((double *)src); src+=8;
		dest_y = *((double *)src); src+=8;
		dest_z = *((double *)src); src+=8;
		bank = *((double *)src); src+=8;
		zoom = *((double *)src); src+=8;

		max_iter  = *((int *)src); src+=4;
		max_depth = *((int *)src); src+=4;
		width     = *((int *)src); src+=4;
		height    = *((int *)src); src+=4;
		aaval     = *((int *)src); src+=4;

//		bgcol_r = dbls[0]; bgcol_g = dbls[1]; bgcol_b = dbls[2];
//		ambli_r = dbls[3]; ambli_g = dbls[4]; ambli_b = dbls[5];
//		eye_rng = dbls[6];
//		src_x = dbls[7]; src_y = dbls[8]; src_z = dbls[9];
//		dest_x = dbls[10]; dest_y = dbls[11]; dest_z = dbls[12];
//		bank = dbls[13]; zoom = dbls[14];
//
//		max_iter = ints[0]; max_depth = ints[1];
//		width = ints[2]; height = ints[3]; aaval = ints[4];

		bbox.min_x = bbox.max_x = src_x;
		bbox.min_y = bbox.max_y = src_y;
		bbox.min_z = bbox.max_z = src_z;

	}

} scene;

struct info_block
{
  double x, y, z, dx, dy, dz, r, g, b, factor;
  hitmode mode;
} info, tmpinfo;

class material                          // Material class
{
public:
  int name;
  double red, green, blue;
  double k_amb, k_diff, k_spec, spot;

  material *next;
  material() {next = 0;}

  void set(char *src)
  {
		name = *((int *)src);
		src+=8;

		red    = *((double *)src); src+=8;
		green  = *((double *)src); src+=8;
		blue   = *((double *)src); src+=8;
		k_amb  = *((double *)src); src+=8;
		k_diff = *((double *)src); src+=8;
		k_spec = *((double *)src); src+=8;
		spot   = *((double *)src); src+=8;

//    red = dbls[0]; green = dbls[1]; blue = dbls[2];
//    k_amb = dbls[3]; k_diff = dbls[4]; k_spec = dbls[5];
//    spot = dbls[6];

  }
} *mat_head = 0;


class lightsrc                          // Lightsource class
{
public:
	double pos_x, pos_y, pos_z;           // Lightsource position
	double red, green, blue;              // Its color
	double intensity;                     // Its intensity

	lightsrc *next;                       // Pointer to next lightsource
	lightsrc() {next = 0;}
	void set( char *src )
	{

		pos_x     = *((double *) src ); src+=8;
		pos_y     = *((double *) src ); src+=8;
		pos_z     = *((double *) src ); src+=8;
		red       = *((double *) src ); src+=8;
		green     = *((double *) src ); src+=8;
		blue      = *((double *) src ); src+=8;
		intensity = *((double *) src ); src+=8;

//    pos_x = dbls[0]; pos_y = dbls[1]; pos_z = dbls[2];
//    red = dbls[3]; green = dbls[4]; blue = dbls[5];
//    intensity = dbls[6];
	}
} *light_head = 0;






// *** GEO ***
// The class 'geo' contains the common elements of all
// geometric shapes to appear in the scene.

class geo *geo_head = 0;

class geo
{
  double pos_x, pos_y, pos_z;               // The object's position
  double nx, ny, nz;
  material *mat;                            // The object's material
  bounding_box bb;                          // The object's bounding box  
  friend class triangle;
  friend class sphere;

public:
  geo *next;
  geo() {next = 0;}                         // Constructor: No succeeding object at the moment
  virtual void set(char *, material *) = 0;

  void get_bbox( double& mi_x, double& ma_x, double& mi_y, double& ma_y, double& mi_z, double& ma_z )
  {
    mi_x = bb.min_z; ma_x = bb.max_x; mi_y = bb.min_y;
    ma_y = bb.max_y; mi_z = bb.min_z; ma_z = bb.max_z;
  }

  virtual void getns(double, double, double) = 0;

  virtual int intersect(double, double, double, double, double, double, double&) = 0;

  void trace(double& zval)
  {
    double t, tt;                           // The affine solution
    double x, y, z;                         // Intersection point and normal vector
    double dx, dy, dz;
    double lx, ly, lz, nl, len, lilen;
    double rdot, rint;
    double specdot;
    int hit;
    lightsrc *li;
    geo *ge;

    if( intersect(info.x, info.y, info.z, info.dx, info.dy, info.dz, t) ) {
      x = t*info.dx; y = t*info.dy; z = t*info.dz;
      len = x*x + y*y + z*z;                // Sqrt omitted for speed
      x += info.x; y += info.y; z += info.z;

      if((len < zval) && (t > 0.000000001)) {
        zval = len;
        getns(x, y, z);                     // Normal vectors

        if(mat->k_spec != 0.0) {
          tmpinfo.factor = mat->k_spec;
          tmpinfo.x = x; tmpinfo.y = y; tmpinfo.z = z;
          tmpinfo.mode = REFLECT; 
          dx = info.dx; dy = info.dy; dz = info.dz;
          normalize(dx,dy,dz);
          rdot = 2*dot(nx,ny,nz, dx,dy,dz);
//        if(rdot<0) rdot=0;
          tmpinfo.dx = -(rdot*nx - dx);     // Optimized
          tmpinfo.dy = -(rdot*ny - dy);
          tmpinfo.dz = -(rdot*nz - dz);
        } else {
          tmpinfo.mode = DIFFUSE;
          tmpinfo.factor = 1.0;
        }

        // Ambient light
        tmpinfo.r = scene.ambli_r * mat->k_amb * mat->red;
        tmpinfo.g = scene.ambli_g * mat->k_amb * mat->green;
        tmpinfo.b = scene.ambli_b * mat->k_amb * mat->blue;

        // Adding light-source induced colour
        li = light_head;

        while(li != 0) {
          lx = li->pos_x - x;
          ly = li->pos_y - y;
          lz = li->pos_z - z;
          lilen = lx*lx + ly*ly + lz*lz;    // Squared length to lightsource

          ge = geo_head;                    // Objects shadowing?
          hit = FALSE;

          while((ge != 0 && !hit)) {
            if(ge != this) {
              hit = ge->intersect(x,y,z, lx,ly,lz, tt);
              if((tt < 0.0) || (tt > 1.0)) hit = FALSE;
            }
            ge = ge->next;
          }

          if(!hit) {

            // was: normalize(lx, ly, lz), this saves a*a+b*b+c*c + automatic inline :)
            specdot = sqrt(lilen);
            lx = lx/specdot;
            ly = ly/specdot;
            lz = lz/specdot;
            // end


            nl = 2 * dot(nx,ny,nz, lx,ly,lz);
            if(nl < 0.0) nl = 0;

            dx = x; dy = y; dz = z + scene.eye_rng;
            normalize(dx,dy,dz);

            lx = -(nl*nx - lx);
            ly = -(nl*ny - ly);
            lz = -(nl*nz - lz);

            rdot = dot(dx,dy,dz, lx,ly,lz);
            if (rdot < 0.0) rdot = 0.0; else rdot = pow(rdot,mat->spot);

            rint = li->intensity / lilen;   // Relative intensity
            specdot = mat->k_spec*rdot;  // optimized

            tmpinfo.r += rint * li->red *   ( mat->k_diff * mat->red   * nl + specdot );
            tmpinfo.g += rint * li->green * ( mat->k_diff * mat->green * nl + specdot );
            tmpinfo.b += rint * li->blue *  ( mat->k_diff * mat->blue  * nl + specdot );
          }
          li = li->next;
        }
      }
    }
  }
};

// The subclass triangle contains the elements neccessary
// to describe a triangle.

class triangle:public geo
{
  double x1,y1,z1, x2,y2,z2, x3,y3,z3;
  double nd;

public:

	void exg(double& a1, double& a2, double& b1, double& b2)
	{
		double tmp;
		tmp = a1; a1 = a2; a2 = tmp;
		tmp = b1; b1 = b2; b2 = tmp;
	}

  void exg(double& a1, double& a2)
  {
    double tmp;
    tmp = a1; a1 = a2; a2 = tmp;    
  }

  // optimize max/min usage???

  void set(char *src, material*mt)
  {
    double max, min;
    double v1, v2, v3, w1, w2, w3;

    mat = mt;

	pos_x = *((double *)src);	src+=8;
	pos_y = *((double *)src);	src+=8;
	pos_z = *((double *)src);	src+=8;

	x1 = *((double *)src);	src+=8;
	y1 = *((double *)src);	src+=8;
	z1 = *((double *)src);	src+=8;
	x2 = *((double *)src);	src+=8;
	y2 = *((double *)src);	src+=8;
	z2 = *((double *)src);	src+=8;
	x3 = *((double *)src);	src+=8;
	y3 = *((double *)src);	src+=8;
	z3 = *((double *)src);	src+=8;

//    x1 = dbls[3]; y1 = dbls[4];  z1 = dbls[5];
//    x2 = dbls[6]; y2 = dbls[7];  z2 = dbls[8];
//    x3 = dbls[9]; y3 = dbls[10]; z3 = dbls[11];

    x1+=pos_x; x2+=pos_x; x3+=pos_x;
    y1+=pos_y; y2+=pos_y; y3+=pos_y;
    z1+=pos_z; z2+=pos_z; z3+=pos_z;

    // Sort in increasing y order

//    if(y2 < y1) exg(x1,x2, y1,y2);
//    if(y3 < y1) exg(x1,x3, y1,y3);
//    if(y3 < y2) exg(x2,x3, y2,y3);

    min = x1; if(x2 < min) min = x2; if(x3 < min) min = x3;
    max = x1; if(x2 > max) max = x2; if(x3 > max) max = x3;
    bb.min_x = min; bb.max_x = max;
    if(min < scene.bbox.min_x) scene.bbox.min_x = min;
    if(max > scene.bbox.max_x) scene.bbox.max_x = min;

    min = y1; if(y2 < min) min = y2; if(y3 < min) min = y3;
    max = y1; if(y2 > max) max = y2; if(y3 > max) max = y3;
    bb.min_y = min; bb.max_y = max;
    if(min < scene.bbox.min_y) scene.bbox.min_y = min;
    if(max > scene.bbox.max_y) scene.bbox.max_y = min;

    min = z1; if(z2 < min) min = z2; if(z3 < min) min = z3;
    max = z1; if(z2 > max) max = z2; if(z3 > max) max = z3;
    bb.min_z = min; bb.max_z = max;
    if(min < scene.bbox.min_z) scene.bbox.min_z = min;
    if(max > scene.bbox.max_z) scene.bbox.max_z = min;

    v1 = x2 - x1; v2 = y2 - y1; v3 = z2 - z1;
    w1 = x3 - x1; w2 = y3 - y1; w3 = z3 - z1;
    nx = v2*w3 - v3*w2; ny = v3*w1 - v1*w3; nz = v1*w2 - v2*w1;
    normalize(nx,ny,nz);
    nd = -(nx*x1 + ny*y1 + nz*z1);          // Plane eq. calculated
  }

  virtual void getns(double, double, double) {};

  virtual int intersect(double x0, double y0, double z0, double dx, double dy, double dz, double& t)
  {

    double de, nxd,nyd,nzd;
    double px, py, pz;
    double lam, my, v1,v2, w1,w2, det;
    double b1,b2,b3,b4, del1, del2;
    int hit_state = FALSE;

    de = (nx*dx + ny*dy + nz*dz);

    if(de != 0.0) {
      t = -(nx*x0 + ny*y0 + nz*z0 + nd) / de;
      px = x0 + t*dx;
      py = y0 + t*dy;
      pz = z0 + t*dz;

      nxd = fabs(nx); nyd = fabs(ny); nzd = fabs(nz);

      if((nzd > nxd) && (nzd > nyd)) {
        v1 = x2-x1; w1 = x3-x1;                // Projection onto the XY-plane
        v2 = y2-y1; w2 = y3-y1;
        del1 = px-x1; del2 = py-y1;
      } else {
        if((nyd > nxd) && (nyd > nxd)) {
          v1 = x2-x1; w1 = x3-x1;              // Projection onto the XZ-plane
          v2 = z2-z1; w2 = z3-z1;
          del1 = px-x1; del2 = pz-z1;
        } else {
          v1 = y2-y1; w1 = y3-y1;              // Projection onto the YZ-plane
          v2 = z2-z1; w2 = z3-z1;
          del1 = py-y1; del2 = pz-z1;
        }
      }

      det = v1*w2 - w1*v2;                     // moved out (save some code :)

      // removed det check here! (nilsco)

      det = 1/det;
      b1 = w2*det; b2 = -w1*det; b3 = -v2*det; b4 = v1*det;
      lam = del1*b1 + del2*b2;
      my  = del1*b3 + del2*b4;

      if((lam >= 0.0) && (my >= 0.0)  && ((lam+my) <= 1.0)) {
        hit_state = TRUE;
        if(dot(nx,ny,nz, dx,dy,dz) > 0.0) {
          nx=-nx; ny=-ny; nz=-nz; nd = -(nx*x1 + ny*y1 + nz*z1);
        }
      }
    }
    return(hit_state);
  }
};

// The subclass sphere contains the elements neccessary
// to describe a sphere.

class sphere:public geo
{
  double radius;

public:
  virtual void set(char *src, material*mt)
  {
    mat = mt;

	pos_x = *((double *)src);	src+=8;
	pos_y = *((double *)src);	src+=8;
	pos_z = *((double *)src);	src+=8;
	radius = *((double *)src);	src+=8;


//    pos_x = dbls[0]; pos_y = dbls[1]; pos_z = dbls[2];
//    radius = dbls[3];
    bb.min_x = pos_x - radius; bb.max_x = pos_x + radius;
    bb.min_y = pos_y - radius; bb.max_y = pos_y + radius;
    bb.min_z = pos_z - radius; bb.max_z = pos_z + radius;

    if(bb.min_x < scene.bbox.min_x) scene.bbox.min_x = bb.min_x;
    if(bb.max_x > scene.bbox.max_x) scene.bbox.max_x = bb.max_x;
    if(bb.min_y < scene.bbox.min_y) scene.bbox.min_y = bb.min_y;
    if(bb.max_y > scene.bbox.max_y) scene.bbox.max_y = bb.max_y;
    if(bb.min_z < scene.bbox.min_z) scene.bbox.min_z = bb.min_z;
    if(bb.max_z > scene.bbox.max_z) scene.bbox.max_z = bb.max_z;
  }

  virtual void getns(double x, double y, double z)
  {
    nx = (x - pos_x)/radius;
    ny = (y - pos_y)/radius;
    nz = (z - pos_z)/radius;
    normalize(nx, ny, nz);
  }

  virtual int intersect(double x0, double y0, double z0, double dx, double dy, double dz, double& t)
  {
    int hit_state = FALSE;
    double a, b;
    double t1, t2;                          // The affine solutions
    double ex, sq;                          // Help variables

    // optimized (nilsco)
    double ztx,zty,ztz;
    double ztl,ztm;

    ztx = x0-pos_x;
    zty = y0-pos_y;
    ztz = z0-pos_z;

    a = dx*dx + dy*dy + dz*dz;
    b = 2*( dx*ztx + dy*zty + dz*ztz );

    ztl = a * (ztx*ztx + zty*zty + ztz*ztz - radius*radius);  // moved c in here (nilsco)
    ztm = a+a;

    ex = b*b - 4*ztl;
    if((ex > 0) && (ztl != 0)) {
      hit_state = TRUE;                     // Intersected
      sq = sqrt(ex);
      t1 = (-b + sq) / ztm;
      t2 = (-b - sq) / ztm;
      t = t1; if((t2 < t1) && (t2 > 0)) t = t2;
      if(t < 0.0) hit_state = FALSE;
    }
    return(hit_state);
  }
};


#ifdef STANDALONE

int getdbls(double *dbls, int top)
{
  char tmp[80];
  for(int i=0; i < top; i++)
  {
    for( zep = 0; (tmp[zep] = *fptr++) != ','; zep++ )
      ;
    tmp[zep] = '\0';

    dbls[i] = atof(tmp);
  }

	return 1;
}

#endif


#ifdef STANDALONE

int getints(int *ints, int top)
{
  char tmp[80];
  for(int i=0; i < top; i++)
  {
    for( zep = 0; (tmp[zep] = *fptr++) != ','; zep++ )
      ;
    tmp[zep] = '\0';

    ints[i] = atoi(tmp);

  }

	return 1;
}

#endif


material *getmat(char *castme)
{
	material *curmat = mat_head;
	int found = FALSE;

	while(!found)
	{
		if( *((int *)castme) == curmat->name ) found = TRUE;
		else curmat = curmat->next;
	}

	return(curmat);
}


// Builds structures

void init_struct( char *presc )
{

	lightsrc *curli = light_head, *li = 0;
	geo *curge = geo_head, *ge = 0;
	material *curmat = mat_head, *mat = 0;

	char *tmpbuf2;
	int comm;

	tmpbuf2 = presc;

	while( (comm = *((int *) tmpbuf2)) != -1 ) {

		tmpbuf2+=8;

		switch(comm) {

		case SCENE:
			scene.set( tmpbuf2 ) ;
			tmpbuf2+=(sizeof(double)*15+sizeof(int)*6);

			break;

		case LIGHT:
			li = new lightsrc;
			if(light_head == 0) light_head = li; else curli->next = li;

			li->set( tmpbuf2 );
			tmpbuf2+=(sizeof(double)*7);

			curli = li;
			break;


		case TRIANGLE:
			ge = new triangle;
			if(geo_head == 0) geo_head = ge; else curge->next = ge;

			mat = getmat(tmpbuf2);
			tmpbuf2+=8;

			ge->set(tmpbuf2,mat);
			tmpbuf2+=sizeof(double)*12;

			curge = ge;
			break;


		case SPHERE:
			ge = new sphere;
			if(geo_head == 0) geo_head = ge; else curge->next = ge;

			mat = getmat(tmpbuf2);
			tmpbuf2+=8;

			ge->set(tmpbuf2,mat);
			tmpbuf2+=sizeof(double)*4;

			curge = ge;
			break;


		case MATERIAL:
			mat = new material;
			if(mat_head == 0) mat_head = mat; else curmat->next = mat;

			mat->set(tmpbuf2);
			tmpbuf2+=(sizeof(int)*2+sizeof(double)*7);

			curmat = mat;
			break;

		}
	}

}



void massacre()
{
  geo *curgeo = geo_head, *nextgeo;
  lightsrc *curli = light_head, *nextli;
  material *curmat = mat_head, *nextmat;

  while(curgeo != 0)                    // Deleting geometric objects
  {
    nextgeo = curgeo->next;
    delete curgeo;
    curgeo = nextgeo;
  }
  geo_head = 0;

  while(curli != 0)                     // Deleting light-sources
  {
    nextli = curli->next;
    delete curli;
    curli = nextli;
  }
  light_head = 0;

  while(curli != 0)                     // Deleting materials
  {
    nextmat = curmat->next;
    delete curmat;
    curmat = nextmat;
  }
  mat_head = 0;
}


//
// *** THE ACTUAL RAYTRACING ***
//


void trace( char *mem_dest )
{
  int bounce, rtms, max_rtms=1;             // Coordinates
  double x1, y1, z1, dx, dy, dz;
  double i,j, fact, zval, bigval;
  double eye_x, eye_y, eye_z, rx, ry, rz, tx, ty, tz, wh, hh;
  double drx, dry, drz, dtx, dty, dtz;
  double red, green, blue ;
#ifdef INTRO
  unsigned char *copyptr;
#endif

#ifdef STANDALONE
  int *ibuf;
#endif

#ifdef PC
  char *temppict2;
  char tmp;
#endif

  geo *ge;

  unsigned char *temppict;


#ifdef STANDALONE
  ibuf = (int *) mem_dest;

  ibuf[0] = 0x59a66a95;
  ibuf[1] = scene.width;
  ibuf[2] = scene.height;
  ibuf[3] = 24;
  ibuf[4] = scene.width * scene.height * 3;
  ibuf[5] = 1;
  ibuf[6] = 0;
  ibuf[7] = 0;
  temppict = (unsigned char *) mem_dest+32;
#else
  temppict = (unsigned char *) mem_dest;
#endif

#ifdef PC

  temppict2 = mem_dest;

  for( i=0; i < 6; i++ ) {

    tmp = temppict2[3];
    temppict2[3]=temppict2[0];
    temppict2[0]=tmp;
    tmp = temppict2[2];
    temppict2[2]=temppict2[1];
    temppict2[1]=tmp;

    temppict2+=4;

  }

#endif

  dx = scene.dest_x - scene.src_x;
  dy = scene.dest_y - scene.src_y;
  dz = scene.dest_z - scene.src_z;
  normalize(dx,dy,dz);

  eye_x = scene.src_x - scene.eye_rng*dx;
  eye_y = scene.src_y - scene.eye_rng*dy;
  eye_z = scene.src_z - scene.eye_rng*dz;

  wh = (double)scene.width / 2.0;
  hh = (double)scene.height / 2.0;

  // Obscure formula ahead :-)

  rx = dz; ry = 0.0; rz = -dx;
  if((rx == 0.0) && (rz == 0.0)) { rx = 1.0; rz = 0.0; }
  else normalize(rx, ry, rz);

  // Up-vector is view-vector crossed with right-vector :-?

  tx = dy*rz - dz*ry; ty = dz*rx - dx*rz; tz = dx*ry - dy*rx;
  
  // zoom is removed here!
  // banking removed! (avoids use of cos/sin) cosb=1, sinb=0

  drx = rx; dry = ry; drz = rz;
  dtx = tx; dty = ty; dtz = tz;


//  normalize(drx,dry,drz); normalize(dtx,dty,dtz);
  rx = -wh*drx + hh*dtx + scene.src_x;
  ry = -wh*dry + hh*dty + scene.src_y;
  rz = -wh*drz + hh*dtz + scene.src_z;

      bigval =                              // Greatest possible length
        (scene.bbox.max_x - scene.bbox.min_x + scene.eye_rng) *
        (scene.bbox.max_x - scene.bbox.min_x + scene.eye_rng) +
        (scene.bbox.max_y - scene.bbox.min_y + scene.eye_rng) *
        (scene.bbox.max_y - scene.bbox.min_y + scene.eye_rng) +
        (scene.bbox.max_z - scene.bbox.min_z + scene.eye_rng) *
        (scene.bbox.max_z - scene.bbox.min_z + scene.eye_rng);

#ifdef STANDALONE
  printf( "    /%4d\r", scene.height );
  fflush(stdout);
#endif

#ifdef INTRO
  for(j = 0; j < (double)scene.height; j+=2) {
    copyptr = temppict;
#else
  for(j = 0; j < (double)scene.height; j++) {
#endif

#ifdef STANDALONE
    printf( "%4d\r", (int) j+1 );
    fflush(stdout);
#endif

#ifdef INTRO
    for(i = 0; i < (double)scene.width; i+=2) {
#else
    for(i = 0; i < (double)scene.width; i++) {
#endif
      red = green = blue = 0.0;

      info.x = eye_x; info.y = eye_y; info.z = eye_z;
      x1 = rx + i*drx - j*dtx;
      y1 = ry + i*dry - j*dty;
      z1 = rz + i*drz - j*dtz;
      info.dx = x1 - info.x; info.dy = y1 - info.y;
      info.dz = z1 - info.z; info.r = 0.0; info.g = 0.0; info.b = 0.0;

//      x1 = rx + i*drx - j*dtx;
//      y1 = ry + i*dry - j*dty;
//      z1 = rz + i*drz - j*dtz;
//      info.x = x1;  info.y = y1;  info.z = z1;
//      info.dx = x1 - eye_x;
//      info.dy = y1 - eye_y;
//      info.dz = z1 - eye_z;




      fact = 1.0;
      rtms = 1;

      do {
        ge = geo_head;
        zval = bigval;

        bounce = FALSE;
        tmpinfo.r = scene.bgcol_r; tmpinfo.g = scene.bgcol_g;
        tmpinfo.b = scene.bgcol_b; tmpinfo.mode = BACKGROUND;

        while(ge != 0) {
          ge->trace(zval);
          ge=ge->next;
        }

        if(tmpinfo.mode == REFLECT) {
          info.x = tmpinfo.x; info.y = tmpinfo.y; info.z = tmpinfo.z;
          info.dx = tmpinfo.dx; info.dy = tmpinfo.dy; info.dz = tmpinfo.dz;
          info.r += fact*tmpinfo.r;
          info.g += fact*tmpinfo.g;
          info.b += fact*tmpinfo.b;
          fact *= tmpinfo.factor;           // Factor for next reflection
          rtms += 1;
          if(rtms <= scene.max_iter) bounce = TRUE;
        } else {
          info.r += fact*tmpinfo.r;
          info.g += fact*tmpinfo.g;
          info.b += fact*tmpinfo.b;
        }

      } while (bounce);

      if(rtms > max_rtms) max_rtms = rtms;
      red += info.r; green +=info.g; blue +=info.b;

      if(red   > 1.0) red = 1.0;
      if(green > 1.0) green = 1.0;
      if(blue  > 1.0) blue = 1.0;
#ifdef INTRO
      *temppict++ = ((unsigned char)(255*red));
      *temppict++ = ((unsigned char)(255*green));
      *temppict++ = ((unsigned char)(255*blue));
      *temppict++ = ((unsigned char)(255*red));
      *temppict++ = ((unsigned char)(255*green));
      *temppict++ = ((unsigned char)(255*blue));
#else
      *temppict++ = ((unsigned char)(255*blue));
      *temppict++ = ((unsigned char)(255*green));
      *temppict++ = ((unsigned char)(255*red));
#endif
    }

#ifdef INTRO
    for( int z=0; z < scene.width*3; z++ ) {

      *temppict++ = *copyptr++;

    }

#endif

  }
}



#ifdef STANDALONE

void cleanup( void )
{
	struct mats *tempmat;
	struct mats *tempmat2;

	if( reader )  free( reader );
	if( mreader ) free( mreader );
	if( parsebuf ) free( parsebuf );

	if( matlist ) {
		tempmat2 = matlist;
		tempmat = matlist;

		while( tempmat2 ) {
			tempmat = tempmat2;
			tempmat2 = tempmat2->nmat;
			free( tempmat );
		}
	}


	exit(0);
}

#endif


#ifdef STANDALONE

// Writes a .pre or .pos file

int dumpstruct( char *fname, char *buffer, int bytes )
{
	int xfileptr;
	int filesize;

	if( (xfileptr = open( fname, O_WRONLY | O_TRUNC | O_CREAT , 0 ))!=-1 ) {

		filesize = write( xfileptr, buffer, bytes );
		if( filesize != bytes )
			cout << "Warning: Output file truncated!\n";

		close( xfileptr );
	} else {
		cout << "\nError: Could not create ouput file '" << fname <<"'!\n";
		return 1;
	}

	return 0;
}

#endif


#ifdef STANDALONE

double *scanpos( char *rbuf, int *noframes, char *outname )
{
	double *pbuf;
	char outbuf[80];

	fptr = rbuf;							// kludge
	getints( noframes, 1 );

	if( !(pbuf = (double *) malloc( sizeof(double)*(*noframes)*6 )) ) {
		cout << "Out of memory!\n";
		return 0;
	} else
		getdbls( pbuf, *noframes*6 );

	strcpy( outbuf, outname );
	strcat( outbuf, ".prepo" );

	if( outname ) {
		if( dumpstruct( outbuf, (char *) pbuf, (*noframes)*6*sizeof(double) ) ) {
			free( pbuf );
			pbuf = 0;
		}
	}

	return pbuf;
}

#endif


#ifdef STANDALONE

char *readfile( char *name, int *fsize )
{
	char *rptr = 0;
	int dfileptr;

	if( rptr = (char *) malloc( 256000 ) ) {

		if( (dfileptr = open( name, O_RDONLY, 0))!=-1 ) {

			*fsize = read( dfileptr, rptr, 256000 );
			*(rptr+(*fsize)) = '\0';

			close( dfileptr );
		} else
			cout << "Couldn't open " << name << " for input!\n";

	} else
		cout << "Out of memory!\n";

	if( *fsize == 0 ) {
		free( rptr );
		rptr = 0;
	}

	return rptr;

}

#endif


#ifdef STANDALONE

struct mats *findmat( char *mname )
{
	struct mats *tempmat;

	tempmat = matlist;

	while( tempmat ) {
		if( !(strcmp( tempmat->matname, mname ) ))
			return tempmat;

		tempmat = tempmat->nmat;
	}

	return NULL;
}

#endif


#ifdef STANDALONE

void addmat( char *mname, int id )
{
	struct mats *tempmat;
	struct mats *newmat;

	newmat = (struct mats *) malloc( sizeof(struct mats) );

	newmat->mid = id;
	strcpy( newmat->matname, mname );

	tempmat = matlist;

	matlist = newmat;
	matlist->nmat = tempmat;

}

#endif


#ifdef STANDALONE

// ******************************************************************
// This function converts the .dat file to the internal file format.
// It contains a lot of checking to avoid errors while tracing.
// If argument outname is specified, a .pre file will be generated
// that can be included in the intro.
// ******************************************************************

char *preparse( char *fptr2, char *outname )
{
	char c;
	char str[80];							// temp command buffer
	int i, found;							// String counter, Boolean, Storage
	int sceneon = 0;
	int fatalerror = 0;
	char *thebuf,*tmpbuf2;				// Dest buffer to be returned
	int newid = 0;


	const char comstr[5][80] = {"scene", "light", "triangle", "sphere", "material"};

	command curcom;						// the current command


	struct mats *curmat = NULL;

	if( !(thebuf = (char *) malloc( 256000 )) )
		return 0;

	tmpbuf2 = thebuf;

	fptr = fptr2;

	while( (c  = *fptr++) != 0 && !fatalerror ) {

		// See if command
		if(c == '#') {

			for( i = 0; (str[i] = *fptr++) != 10; i++ )
				;
			str[i] = '\0';

			found = FALSE;
			curcom = UNDEF;
			i = 999;

			// Find command in comstr array
			while(!found && i < UNDEF) {
				if(strcmp(str,comstr[i-999])==0) {
					curcom = (command)i;
					found = TRUE;
				} else
					i++;
			}


			switch(curcom) {

			// Scene is: 15 doubles + 5 ints, unique
			case SCENE:

				if( !sceneon ) {
					*((int *) tmpbuf2) = (int) SCENE;
					tmpbuf2+=8;

					if( getdbls( (double *) tmpbuf2, 15 ) ) {

						tmpbuf2+= sizeof(double)*15;

						if( getints( (int *) tmpbuf2, 5 ) ) {

							tmpbuf2+= sizeof(int)*6;
							sceneon = 1;

						} else {
							cout << "Error: [scene] Could not read data!\n";
							fatalerror = 1;
						}

					} else {
						cout << "Error: [scene] Could not read data!\n";
						fatalerror = 1;
					}

				} else {
					cout << "Error: Scene can only be defined once!\n";
					fatalerror = 1;
				}
				break;

			// Lightsource is: 7 doubles
			case LIGHT:
				*((int *) tmpbuf2) = (int) LIGHT;
				tmpbuf2+=8;


				if( getdbls( (double *) tmpbuf2, 7 ) ) {
					tmpbuf2+= (sizeof(double)*7);
				} else {
					cout << "Error: [light] Could not read data!\n";
					fatalerror = 1;
				}
				break;

			// Triangle is: matid + 12 doubles
			case TRIANGLE:
				*((int *) tmpbuf2) = (int) TRIANGLE;
				tmpbuf2+=8;

				// get name
				for( zep = 0; (str[zep] = *fptr++) != ','; zep++ )
				  ;
				str[zep] = '\0';

				if( curmat = findmat( str ) ) {

					*((int *) tmpbuf2) = curmat->mid;
					tmpbuf2+=8;

					if( getdbls( (double *) tmpbuf2, 12 ) ) {
						tmpbuf2+= sizeof(double)*12;
					} else {
						cout << "Error: [triangle] Could not read data!\n";
						fatalerror = 1;
					}
				} else {
					cout << "Error: [triangle] Could not find material " << str << "!\n";
					fatalerror = 1;
				}

				break;


			// Sphere is: matid + 4 doubles
			case SPHERE:
				*((int *) tmpbuf2) = (int) SPHERE;
				tmpbuf2+=8;

				// get name
				for( zep = 0; (str[zep] = *fptr++) != ','; zep++ )
				  ;
				str[zep] = '\0';

				if( curmat = findmat( str ) ) {

					*((int *) tmpbuf2) = curmat->mid;
					tmpbuf2+=8;

					if( getdbls( (double *) tmpbuf2, 4 ) ) {
						tmpbuf2+= sizeof(double)*4;
					} else {
						cout << "Error: [sphere] Could not read data!\n";
						fatalerror = 1;
					}
				} else {
					cout << "Error: [sphere] Could not find material " << str << "!\n";
					fatalerror = 1;
				}

				break;


			// Material is: matid + 7 doubles

			case MATERIAL:
				*((int *) tmpbuf2) = (int) MATERIAL;
				tmpbuf2+=8;

				// get name
				for( zep = 0; (str[zep] = *fptr++) != ','; zep++ )
				  ;
				str[zep] = '\0';

				if( !(curmat = findmat( str )) ) {

					addmat( str, newid );

					*((int *)tmpbuf2) = newid++;
					tmpbuf2+=8;

					if( getdbls( (double *) tmpbuf2, 7 ) ) {
						tmpbuf2+= (sizeof(double)*7);
					} else {
						cout << "Error: [material] Could not read data!\n";
						fatalerror = 1;
					}
				} else {
					cout << "Error: [material] " << str << " already defined!\n";
					fatalerror = 1;
				}
				break;

			default:
				cout << "Warning: " << str << " is an unknown command and will be ignored!\n";
				break;
			}
		}
	}

	if( !sceneon ) {
		cout << "You forgot to define a scene!\n";
		fatalerror = 1;
	}

	if( fatalerror ) {
		free( thebuf );
		thebuf = 0;
	} else {
		cout << "Parsing ok!\n" ;
		*((int *)tmpbuf2) = -1;
		tmpbuf2+=8;

		strcpy( str, outname );
		strcat( str, ".presc" );

		if( outname ) {
			if( dumpstruct( str, thebuf, tmpbuf2-thebuf ) ) {
				free( thebuf );
				thebuf = 0;
			}
		}
	}

	return thebuf;

}

#endif


#ifdef STANDALONE

int dotrace( int frames, double *doubles, char *prescene, char *basename )
{
	int i;
	int retval = 1;
	int xfileptr;
	unsigned long filesize;
	char outname[33];

	for( i = 0; i < frames; i++ ) {

		init_struct( prescene );
//		read_data( reader );

		if( pict = (char *) malloc( scene.width*scene.height*3+32 ) ) {

			// prep new frame
			if( frames > 1 ) {

				printf( "           Frame: %4d/%4d\r", i+1, frames );

				scene.src_x  = doubles[0+i*6];
				scene.src_y  = doubles[1+i*6];
				scene.src_z  = doubles[2+i*6];
				scene.dest_x = doubles[3+i*6];
				scene.dest_y = doubles[4+i*6];
				scene.dest_z = doubles[5+i*6];

			}

			trace( pict );
			massacre();


			sprintf( outname, "%s%03d", basename, i+1 );

			if( (xfileptr = open( outname, O_WRONLY | O_TRUNC | O_CREAT , 0 ))!=-1 ) {

				filesize = write( xfileptr, pict, scene.width*scene.height*3+32 );
				if( filesize != scene.width*scene.height*3+32 ) cout << "Warning: Output file truncated!\n";

				close( xfileptr );
			} else {
				cout << "\nError: Could not create ouput file '" << outname <<"'!\n";
				i = frames;
				retval = 0;
			}

			free( (void *) pict );


		} else {

			cout << "\nError: Could not allocate output picture buffer!\n";
			retval = 0;
		}

	}     // for

	return retval;
}

#endif


#ifdef STANDALONE

int main( int argc, char *argv[] )
{
	char version[] = "$VER: Tracey 0.3 (22.02.95)";

	int frames;
	int readersize,mreadersize;
	char *destname = 0;

	cout << "Original tracer by Per Christian degrd\n";
	cout << "Tracer 0.3 (22.02.95) by Nils Corneliusen of Triumph Software\n";
	cout << "-------------------------------------------------------------\n";
	cout << "Internal release - do not distribute\n";

	if( argc <= 2 || argc > 5 ) {
		cout << "Usage: Tracey <scene> <outfile>\n";
		cout << "<scene>:   A scene descriptor in Tracey format.\n";
		cout << "<outfile>: Base output file name (sunraster24).\n";
		cout << "[posfile]: Optional position file.\n";
		cout << "[genpre]:  Generate precompiled versions of scene and posfile.\n";
		return 0;
	}

	if( (argc == 5) || (argc == 4) ) {
		if( !(strcmp( argv[argc-1], "genpre")) ) {
			puts( "You want pre/pos files..." );
			destname = argv[2];
		}
	}


	cout << "Reading scene file...\n";
	if( !(reader = readfile( argv[1], &readersize )) ) 
		cleanup();

	cout << "Parsing scene file...\n";
	if( !(prescene = preparse( reader, destname )) )
		cleanup();


	if( (argc == 4 && destname == 0) || argc == 5 ) {

		cout << "Reading position file...\n";
		if( !(mreader = readfile( argv[3], &mreadersize )) )
			cleanup();

		cout << "Parsing position file...\n";
		if( !(parsebuf = scanpos( mreader, &frames, destname )) ) 
			cleanup();

	} else
		frames = 1;

	if( !(dotrace( frames, parsebuf, prescene, argv[2] )) ) {
		cout << "\nTrace failed!\n";
		cleanup();
	}

	cout << "\nFinished!\n";
	cleanup();

	return 0;
}

#endif


#ifdef INTRO

/***
 * Hook to call from intro
 ***/

extern void traceme( char *desc, char *mem_dest )
{
	init_struct( desc );
	trace( mem_dest );
	massacre();
}

int main( void )
{
	puts( "Speed - give me what I need... money!" );

	asmHitMe();
	traceme( ScenePtr, DestPtr );
	entf1();
	traceme( ScenePtr, DestPtr );
	entf1();
	traceme( ScenePtr, DestPtr );
	entf1();
	traceme( ScenePtr, DestPtr );
	entf1();
	traceme( ScenePtr, DestPtr );
	entf1();
	traceme( ScenePtr, DestPtr );
	ents1();

	return 0;
}

#endif
